// object that can be moved around on ground by the blue alien

class Box extends InteractiveWorldObject {
  int timeLastActed = timeOutTime;
  String whichGround;                      // the type of ground that would be underneath the box
  String tempWhichGround;
  AudioPlayer boxNoise = minim.loadFile("sound/zapsplat_foley_cardboard_box_heavy_slide_concrete_garage_floor_005_34627.mp3");

  Box(int _x, int _y, String _whichGround) {
    x = _x;
    y = _y;
    walkable = false;
    whichGround = _whichGround;
  }
  //---------------------------------------------------------

  void draw() {
    image(boxImg, x, y, 1, 1);
  }
  //---------------------------------------------------------

  void act() {
    boxNoise.rewind();
    boxNoise.play();

    // draw on new position before alien so box stays visible
    draw();
  }
  //---------------------------------------------------------

  void tryMoving(int moveByX, int moveByY) {
    // only acts once every second
    if (timeLastActed > timer) {
      int newX = x + moveByX;
      int newY = y + moveByY;

      if ((newX < NUM_TILES_X) && (newX >= 0) && (newY < NUM_TILES_Y) && (newY >= 0)) {    // in bounds?
        if (wObjectsInLevel[newX][newY] instanceof Ground) {
          tempWhichGround = wObjectsInLevel[newX][newY].whichObject;
          wObjectsInLevel[newX][newY] = this;
          wObjectsInLevel[x][y] = new Ground(x, y, whichGround);
          this.x = newX;
          this.y = newY;
          whichGround = tempWhichGround;

          act();
        }
      }
      timeLastActed = timer;
    }
  }
}
