import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import controlP5.*; 
import ddf.minim.*; 
import java.util.*; 
import java.lang.Math.*; 
import controlP5.*; 
import controlP5.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Game extends PApplet {

//Plug-In for Buttons


public LevelEditor levelEditor;

public GameMode currentGameMode;
public HomeMode homeMode;
public GameRunningMode grm;
public GameWonMode gwm;
public GameLostMode glm;
public GameTutorialMode gtm;
public GameCreditsMode gcm;
public UI ui;

ControlP5 cp5;


PImage alien1Img;
PImage alien2Img;
PImage humanImg;
PImage speechBubbleImg;
PImage exclamationPointImg;

PImage boxImg;
PImage greenButtonImg;
PImage gardenGateLeftImg;
PImage gardenGateRightImg;
PImage gardenGateBottomImg;
PImage gardenGateTopImg;
PImage barrierLeftImg;
PImage barrierMiddleImg;
PImage barrierRightImg;
PImage doorTopImg;
PImage doorRightImg;
PImage doorBottomImg;
PImage doorLeftImg;
PImage leavesImg;
PImage streetImg;
PImage footpathImg;
PImage l3GroundImg;
PImage carpetImg;
PImage carpetTopLeftImg;
PImage carpetTopRightImg;
PImage carpetBottomLeftImg;
PImage carpetBottomRightImg;
PImage carpetSideTopImg;
PImage carpetSideBottomImg;
PImage lampImg;
PImage bucketImg;
PImage tvImg;
PImage treeImg;
PImage ufoImg;
PImage bushImg;
PImage wallWithHoleImg;
PImage grassImg;
PImage roofImg;
PImage housewallImg;
PImage plantImg;
PImage sofaImg;
PImage tableImg;


Minim minim = new Minim(this);
AudioPlayer bgMusic;

public void setup() {

  cp5 = new ControlP5(this);

  
  //Startet einen bestimmtem Mode
  ui = new UI(this);

  homeMode = new HomeMode(this, cp5, ui);
  grm = new GameRunningMode(this, cp5, ui);
  gwm = new GameWonMode(this, cp5, ui);
  glm = new GameLostMode(this, cp5, ui);
  gtm = new GameTutorialMode(this, cp5, ui);
  gcm = new GameCreditsMode(this, cp5, ui);
  currentGameMode = homeMode;

  ui.updateUI();

  bgMusic = minim.loadFile("sound/Guerilla Tactics.mp3");
  bgMusic.loop();

  // load Images for Characters and Assets
  alien1Img = loadImage("characters/alien_01.png");
  alien2Img = loadImage("characters/alien_02.png");
  humanImg = loadImage("characters/human.png");
  speechBubbleImg = loadImage("characters/speech_bubble.png");
  exclamationPointImg = loadImage("characters/exclamation_point.png");

  boxImg = loadImage("assets/box_01.png");
  greenButtonImg = loadImage("assets/button.png");
  gardenGateLeftImg = loadImage("assets/door/gardenGate_l.png");      
  gardenGateRightImg = loadImage("assets/door/gardenGate_r.png");
  gardenGateBottomImg = loadImage("assets/door/gardenGate_b.png");
  gardenGateTopImg = loadImage("assets/door/gardenGate_t.png");
  barrierLeftImg = loadImage("assets/door/barrier_l.png");
  barrierMiddleImg = loadImage("assets/door/barrier_m.png");
  barrierRightImg = loadImage("assets/door/barrier_r.png");
  doorTopImg = loadImage("assets/door/door_t.png");
  doorRightImg = loadImage("assets/door/door_r.png");
  doorBottomImg = loadImage("assets/door/door_b.png");
  doorLeftImg = loadImage("assets/door/door_l.png");
  leavesImg = loadImage("assets/test_leaves.png");
  streetImg = loadImage("assets/street_02.png");
  footpathImg = loadImage("assets/footpath_01.png");
  l3GroundImg = loadImage("assets/l3_ground_01.png");
  carpetImg = loadImage("assets/carpet/carpet_small.png");
  carpetTopLeftImg = loadImage("assets/carpet/carpet_tl.png");
  carpetTopRightImg = loadImage("assets/carpet/carpet_tr.png");
  carpetBottomLeftImg = loadImage("assets/carpet/carpet_bl.png");
  carpetBottomRightImg = loadImage("assets/carpet/carpet_br.png");
  carpetSideTopImg = loadImage("assets/carpet/carpet_side_top.png");
  carpetSideBottomImg = loadImage("assets/carpet/carpet_side_bottom.png");
  lampImg = loadImage("assets/lamp_01.png");
  bucketImg = loadImage("assets/bucket_01.png");
  tvImg = loadImage("assets/tv_01.png");
  treeImg = loadImage("assets/LOE_tree_light.png");
  ufoImg = loadImage("assets/ufo.png");
  bushImg = loadImage("assets/busch.png");
  wallWithHoleImg = loadImage("assets/l3_wall_with_hole.png");
  grassImg = loadImage("assets/gras_01.png");
  roofImg = loadImage("assets/roof_01.png");
  housewallImg = loadImage("assets/l3_wall_01.png");
  plantImg = loadImage("assets/plant_01.png");
  sofaImg = loadImage("assets/sofa_big.png");
  tableImg = loadImage("assets/tabel_big.png");
}

public void draw() {
  //Show HomeMode Screen first
  if (currentGameMode != null) {
    currentGameMode.drawGame();
  }
}
// object that can be moved around on ground by the blue alien

class Box extends InteractiveWorldObject {
  int timeLastActed = timeOutTime;
  String whichGround;                      // the type of ground that would be underneath the box
  String tempWhichGround;
  AudioPlayer boxNoise = minim.loadFile("sound/zapsplat_foley_cardboard_box_heavy_slide_concrete_garage_floor_005_34627.mp3");

  Box(int _x, int _y, String _whichGround) {
    x = _x;
    y = _y;
    walkable = false;
    whichGround = _whichGround;
  }
  //---------------------------------------------------------

  public void draw() {
    image(boxImg, x, y, 1, 1);
  }
  //---------------------------------------------------------

  public void act() {
    boxNoise.rewind();
    boxNoise.play();

    // draw on new position before alien so box stays visible
    draw();
  }
  //---------------------------------------------------------

  public void tryMoving(int moveByX, int moveByY) {
    // only acts once every second
    if (timeLastActed > timer) {
      int newX = x + moveByX;
      int newY = y + moveByY;

      if ((newX < NUM_TILES_X) && (newX >= 0) && (newY < NUM_TILES_Y) && (newY >= 0)) {    // in bounds?
        if (wObjectsInLevel[newX][newY] instanceof Ground) {
          tempWhichGround = wObjectsInLevel[newX][newY].whichObject;
          wObjectsInLevel[newX][newY] = this;
          wObjectsInLevel[x][y] = new Ground(x, y, whichGround);
          this.x = newX;
          this.y = newY;
          whichGround = tempWhichGround;

          act();
        }
      }
      timeLastActed = timer;
    }
  }
}
// object that can trigger the action of another interactive object; can be pushed by the blue alien

class Button extends InteractiveWorldObject {
  InteractiveWorldObject connectedObject;
  AudioPlayer noise;

  Button(int _x, int _y, String _whichObject, InteractiveWorldObject _connectedObject) {
    x = _x;
    y = _y;
    walkable = true;
    whichObject = _whichObject;
    connectedObject = _connectedObject;
    switch (whichObject) {
    case "green button":
    }
    noise = minim.loadFile("sound/zapsplat_technology_cb_radio_talk_button_release_10365.mp3");
  }
  //---------------------------------------------------------

  public void draw() { 
    imageMode(CORNER);
    image(greenButtonImg, x, y, 1, 1 );
  }
  //---------------------------------------------------------

  // calls act() of connected object
  public void act() {
    this.noise.rewind();
    this.noise.play();
    connectedObject.act();
  }
}
static int lastUsedCharacterID = 0;

abstract class GameCharacter {
  int characterID;
  int posX;        //tile-coordinates
  int posY;

  GameCharacter() {
    characterID = lastUsedCharacterID++;
  }

  public abstract void draw();    

  // redraws background color, so characters don't leave a trail
  public void redrawBG(int x, int y) {
    fill(grm.world.bg);
    rectMode(CORNER);
    rect(x-0.02f, y-0.02f, 1.04f, 1.04f);
  }
}


class Human extends GameCharacter {
  //characteristics of the human
  boolean reactsToNoiseItem;
  float fieldOfView;                             //angle in degrees, how broad is the humans field of view
  int sightDistance;                             //how far can the human see
  boolean hasLamp;

  //runtime characteristics
  int posX, posY;
  int nextX, nextY;
  int state;
  WorldObject goal;                                                 //current goal
  int [][] goals = new int [3][2];                                  //3 randomly generated points where the npc wanders inbetween. 
  PVector orientation = new PVector(1, 0);                          //where is the NPC looking, initial state does not matter.
  int targetCharacter;
  boolean [][] visible = new boolean [NUM_TILES_X][NUM_TILES_Y];    //tiles the human can see. In a world sized array, since reallocating space would probably take more time than working like this.
  WorldObject noiseItem;                                            //target that can be triggered, affects reactToNoiseItem = true - humans

  //for pathfinding
  HashSet<WorldObject> visited = new HashSet<WorldObject>();                                //tracks visited tiles      
  Queue<WorldObject> adjacent = new LinkedList<WorldObject>();                              //stores the tiles that need checking
  HashMap <WorldObject, WorldObject> previous = new HashMap<WorldObject, WorldObject>();    //for backtracking. stores the predecessors of the visited tiles

  //audio
  AudioPlayer giveUp;
  AudioPlayer heardSomething;
  AudioPlayer talking;
  AudioPlayer greeting;
  int soundNumber = round(random(-0.49f, 2.5f));

  //timer & cooldowns
  final int PATROL_RADIUS = 8;

  final int TIME_LOOKING_AROUND = 5000;

  final int ALIEN_DETECTION_RADIUS = 4; 
  final int HUMAN_DETECTION_RADIUS = 6;

  float lastAlerted = 0.0f;
  final float ALERT_COOLDOWN = 10000.0f; 
  final float ALERT_DELAY = 1000;

  float lastTalk = 0;
  final float TALKING_COOLDOWN = 10000;
  final float MAX_TALK_DURATION = 5000;

  float lastNoiseAlert = 0.0f;
  final float NOISE_COOLDOWN = 1000;

  float stateStartTime = 0;

  final float ENDURANCE = 6000;   
  float chasingTimer = 0;

  //states
  final int STILL = 0;
  final int PATROLING = 1;
  final int CHASING = 2;
  final int GREETING = 3;
  final int TALKING = 4;
  final int LOOKING = 5;
  final int HEARD_NOISE_ITEM = 6;

  Human(int _posX, int _posY, int _state, float _fieldOfView, int _sightdistance, boolean _hasLamp, boolean _reactsToNoiseItem) {
    characterID = super.characterID;
    posX = _posX;
    posY = _posY;
    state = _state;
    reactsToNoiseItem = _reactsToNoiseItem;
    sightDistance = _sightdistance;
    fieldOfView = _fieldOfView;
    hasLamp = _hasLamp;

    switch (soundNumber) {
    case 0:
      giveUp = minim.loadFile("sound/humans/zapsplat_human_male_sigh_tired_19877.mp3");
      heardSomething = minim.loadFile("sound/humans/zapsplat_human_male_grunt_confused_002_19853.mp3");
      talking = minim.loadFile("sound/humans/Humans_talkingXD.mp3");
      greeting = minim.loadFile("sound/humans/happyHumanFindingHumans.mp3");
      break;
    case 1:
      giveUp = minim.loadFile("sound/humans/zapsplat_human_male_sigh_tired_19877_2.mp3");
      heardSomething = minim.loadFile("sound/humans/zapsplat_human_male_grunt_confused_002_19853_2.mp3");
      talking = minim.loadFile("sound/humans/Humans_talkingXD_2.mp3");
      greeting = minim.loadFile("sound/humans/happyHumanFindingHumans_2.mp3");
      break;
    case 2:
      giveUp = minim.loadFile("sound/humans/zapsplat_human_male_sigh_tired_19877_3.mp3");
      heardSomething = minim.loadFile("sound/humans/zapsplat_human_male_grunt_confused_002_19853_3.mp3");
      talking = minim.loadFile("sound/humans/Humans_talkingXD_3.mp3");
      greeting = minim.loadFile("sound/humans/happyHumanFindingHumans_3.mp3");
      break;
    }

    generateGoals();

    if (state != STILL) {
      goal = getNewGoal(posX, posY);
      state = PATROLING;
    }
  }

  public void move() {
    redrawBG(posX, posY);      //for smoother drawing
    if (state == CHASING) {
      redrawBG(posX, posY-1);
    }

    switch(state) {
    case STILL:  //do nothing
      break;

      //move towards the next goal. if you're there, change state to Looking
    case PATROLING: 
      setNextStep(posX, posY, goal.x, goal.y);
      orientation.set(nextX-posX, nextY-posY);
      orientation.normalize();
      goToNext();
      if (goal == wObjectsInLevel[posX][posY]) {
        state = LOOKING;
        stateStartTime = millis();
      }
      break;

      //chasing aliens. after a delay occured, move towards the targeted alien. After some time give up and return to Patroling
    case CHASING:
      if ((millis()-lastAlerted)>ALERT_DELAY) {
        if (chasingTimer < ENDURANCE) {
          if (targetCharacter == alien1.characterID) {
            setNextStep(posX, posY, alien1.posX, alien1.posY);
            orientation.set(alien1.posX-posX, alien1.posY - posY);
          } else {
            setNextStep(posX, posY, alien2.posX, alien2.posY);
            orientation.set(alien2.posX-posX, alien2.posY - posY);
          }
          orientation.normalize();
          goToNext();
          chasingTimer = (millis() - stateStartTime);
        } else {
          chasingTimer = 0;
          this.giveUp.rewind();
          this.giveUp.play();
          goal = getNewGoal(-1, -1);
          state = PATROLING;
          stateStartTime = millis();
        }
      }
      break;

      //after spotting a human, greet him and move closer. Once there, start talking
    case GREETING: 
      for (Human human : humans) {
        println(targetCharacter);
        if (targetCharacter == human.characterID) {
          setNextStep(posX, posY, human.posX, human.posY); 
          orientation.set(human.posX-posX, human.posY - posY);
          orientation.normalize();
          if (dist(posX, posY, human.posX, human.posY)>1) {
            goToNext();
          } else {
            state = TALKING;
            this.talking.rewind();
            this.talking.play();
            human.state = TALKING;
            human.talking.rewind();
            human.talking.play();
            stateStartTime = millis();
            human.stateStartTime = millis();
          }
        }
      }
      break;

      //talk for MAX_TALK_DURATION seconds, then, start patroling again
    case TALKING:
      float talkDuration = (millis()-stateStartTime);           
      if (MAX_TALK_DURATION - talkDuration <= 0) {
        lastTalk = millis();
        talkDuration = 0;
        goal = getNewGoal(posX, posY);
        state = PATROLING;
        stateStartTime = millis();
      }
      break;

      //After reaching a goal, look around for a few seconds. Then, start patroling again
    case LOOKING:
      float fractionOfTime = (millis()-stateStartTime)/(TIME_LOOKING_AROUND/2);
      if (fractionOfTime <= 0.5f) {
        orientation.rotate(PI*fractionOfTime);
      } else if (fractionOfTime >= 0.5f && fractionOfTime <= 1) {
        orientation.rotate(PI*fractionOfTime);
      } else {
        goal = getNewGoal(goal.x, goal.y);  
        state = PATROLING;
        stateStartTime = millis();
      }
      break;

      //After NoiseItem was triggered, move towards it. When there interact with it and Look around.
    case HEARD_NOISE_ITEM:
      setNextStep(posX, posY, goal.x, goal.y);
      if (posX == goal.x && posY == goal.y) {
        ((NoiseItem)wObjectsInLevel[noiseItem.x][noiseItem.y]).act();
        state = LOOKING;
        stateStartTime = millis();
      }
      orientation.set(goal.x-posX, goal.y - posY);
      orientation.normalize();
      goToNext();
      break;

    default: //do nothing
      break;
    }
  }


  public void draw() {
    image(humanImg, posX, posY, 1, 1); 
    if (state == TALKING) {
      image(speechBubbleImg, posX, posY-1, 1, 1);
    } else if (state == CHASING) {
      image(exclamationPointImg, posX, posY-1, 1, 1);
    }
    fov(posX, posY);    //determine visible tiles
    lightTiles();       
    detectAliens();    
    checkSurroundings();
  }


  //lights visible World tiles if the npc has a lamp
  public void lightTiles() {
    if (hasLamp) {
      for (int i= 0; i<NUM_TILES_X; i++) {                              
        for (int o = 0; o<NUM_TILES_Y; o++) {
          if (!litTiles[i][o]) {
            litTiles[i][o] = visible[i][o];
          }
        }
      }
    }
  }

  /*
  fills the visible array with tiles that are visible to the NPC. They are based on the fieldOfView, orientation and sightDistance of the npc and the surrounding geometry
   creator: Mithreindeir on Youtube, "How To - Field of View Algorithm For roguelikes", abgerufen am 22.12.2020, übersetzt in Java aus C (vermutlich)
   */
  public void fov(int posX, int posY) {          
    float x;
    float y;
    final float DEG_RAD_CONV = PI/180;
    int drehung = round((orientation.heading()/DEG_RAD_CONV)-(fieldOfView/2));  //orientation of the human converted in degrees

    for (int i= 0; i<NUM_TILES_X; i++) {                              //reset visible Array
      for (int o = 0; o<NUM_TILES_Y; o++) {
        visible[i][o] = false;
      }
    }


    for (int i = 0 + drehung; i<fieldOfView + drehung; i+=4) {                //turn step by step
      float deg = i*DEG_RAD_CONV;

      x = (cos(deg) * sightDistance) + posX;                                  //set lines to endpoints
      y = (sin(deg) * sightDistance) + posY;

      int d = round(dist(posX, posY, x, y));

      for (int u = 0; u<d; u++) {
        int tileX = round(lerp(posX, x, u/(float)d));                         //interpolate along the lines
        int tileY = round(lerp(posY, y, u/(float)d));        

        if (tileX < 0 || tileX >= NUM_TILES_X) {                              //ignore out of bounds
          continue;
        }    //check bounds
        if (tileY < 0 || tileY >= NUM_TILES_Y) {
          continue;
        }

        if (!wObjectsInLevel[tileX][tileY].walkable) {                        //if you hit a wall, door or other dont continue
          break;
        }
        visible[tileX][tileY] = true;                                         //set the current (interpolated) tile as visible
      }
    }
  }

  /*
  if aliens are in view and lit or on the same tile as the npc, end game
   */
  public void detectAliens() {
    if (visible[alien1.posX][alien1.posY]) {
      if (litTiles[alien1.posX][alien1.posY] || (alien1.posX == posX && alien1.posY == posY)) {
        MainGame.currentGameMode = MainGame.glm; 
        MainGame.currentGameMode.start(false);
      }
    }
    if (visible[alien2.posX][alien2.posY]) {
      if (litTiles[alien2.posX][alien2.posY] || (alien2.posX == posX && alien2.posY == posY)) {
        MainGame.currentGameMode = MainGame.glm; 
        MainGame.currentGameMode.start(false);
      }
    }
  }

  /*
  if not distracted, "listen" for aliens/humans in range, react accordingly
   */
  public void checkSurroundings() { 
    if (state != CHASING && state != TALKING && state != HEARD_NOISE_ITEM) {                                                                             //if not heavily distracted (chasing a alien, talking or looking for the noise)
      if (dist(posX, posY, alien1.posX, alien1.posY)<= ALIEN_DETECTION_RADIUS || dist(posX, posY, alien2.posX, alien2.posY)<= ALIEN_DETECTION_RADIUS) {  //is any alien in detection distance
        if (dist(posX, posY, alien1.posX, alien1.posY)<= ALIEN_DETECTION_RADIUS && (millis()-lastAlerted >= ALERT_COOLDOWN)) {                           //is it alien 1 and is the alert off cooldown?
          targetCharacter = alien1.characterID;
          lastAlerted = millis();
          state = CHASING;
          this.heardSomething.rewind();
          this.heardSomething.play();
          stateStartTime = millis();
        }
        if (dist(posX, posY, alien2.posX, alien2.posY)<dist(posX, posY, alien1.posX, alien1.posY) && (millis()-lastAlerted >= ALERT_COOLDOWN)) {        //is alien 2 closer and the alert off cooldown?
          targetCharacter = alien2.characterID;
          lastAlerted = millis();
          state = CHASING;
          this.heardSomething.rewind();
          this.heardSomething.play();
          stateStartTime = millis();
        }
      } else {                                                                                                                                          //aliens have priority over humans
        if (state != GREETING) {
          for (Human human : humans) {                                                                                                                  //check all humans
            if (this == human) {                                                                                                                        //ignore yourself
              continue;
            }
            if (dist(posX, posY, human.posX, human.posY)<= HUMAN_DETECTION_RADIUS && (millis()-lastTalk >= TALKING_COOLDOWN)) {                        //if close, start the greeting :)
              targetCharacter = human.characterID;
              human.targetCharacter = this.characterID;
              state = GREETING;
              this.greeting.rewind();
              this.greeting.play();
              human.state = GREETING;
              human.greeting.rewind();
              human.greeting.play();
              stateStartTime = millis();
              human.stateStartTime = millis();
            }
          }
        }
      }
    }
  }


  /*
  generates 3 random goals in PATROL_RADIUS range
   */
  public void generateGoals() {
    randomSeed(millis());
    int randomX = 0;
    int randomY = 0;
    for (int i = 0; i<=2; i++) {                                                   //change here if one wants to use more random goals.
      do {                                                                         //fill with random points in the patrol_radius
        randomX = posX;                                                            //if initialized with STILL, we only want them to move if called. Else, they should walk back to start -> all entries are posX/posY
        randomY = posY;
        if (state == STILL) {                                                      //in 1 case choose a different one, so getNewGoal doesnt loop
          if (i%2 == 1) {
            randomX = posX-1;
            randomY = posY;
          }
        } else {
          randomY = posY + round(random(-PATROL_RADIUS, PATROL_RADIUS));
          randomX = posX + round(random(-PATROL_RADIUS, PATROL_RADIUS));
        }
      } while (!isWalkableForHumans(randomX, randomY));
      goals[i][0] = randomX;
      goals[i][1] = randomY;
    }
  }

  /*
  returns true if the tile at (x/y) is walkable for humans
   */
  public boolean isWalkableForHumans(int x, int y) {              
    if (x<0 || x>=NUM_TILES_X|| y<0 || y>=NUM_TILES_Y) {                                                                                    //if out of bounds
      return false;
    } 

    if (wObjectsInLevel[x][y].walkable || (wObjectsInLevel[x][y] instanceof DoorPiece && ((DoorPiece)wObjectsInLevel[x][y]).humanCanOpen))  //if walkable or a openable door
    {
      if ((wObjectsInLevel[x][y] instanceof Ground) && ((Ground)wObjectsInLevel[x][y]).onlyAliens) {                                        //if its a path only for aliens -functionality for a planned level-
        return false;
      } else {
        return true;
      }
    } else {
      return false;
    }
  }

  /*
  determines the next Step on the way to the goal. Done with Breadth-First-Search
   */
  public void setNextStep(int currentX, int currentY, int destinationX, int destinationY) {

    if (currentX == destinationX && currentX == destinationY) {                              //trivial, no path needed
      state = LOOKING;
      nextX = currentX;
      nextY = currentY;
      return;
    }

    WorldObject current;
    WorldObject destination;
    WorldObject temp;

    current = wObjectsInLevel[currentX][currentY]; 
    destination = wObjectsInLevel[destinationX] [destinationY];

    adjacent.add(current);

    while (!adjacent.isEmpty()) {                                                                                                  //as long as there are tiles that need to be checked
      current = adjacent.remove();

      if (current == destination) {                       //we are at the destination, so add last step and start backtracking.
        WorldObject next;
        next = backtrack(previous, destination);          //set the next tile on the path to the goal
        nextX = next.x;
        nextY = next.y;
        visited.clear();                                  //reset
        adjacent.clear();
        previous.clear();
        return;
      }

      //check north
      if ( isWalkableForHumans(current.x, current.y-1)) {
        temp = wObjectsInLevel[current.x][current.y-1];
        if (!(visited.contains(temp)) && isWalkableForHumans(current.x, current.y-1)) {                                               //if its not already visited and walkable
          adjacent.add(temp);                                                                                                       //add to the list of tiles to be checked
          previous.put(temp, current);                                                                                              //safe the predecessor in the designated table
        }
      }

      //check east
      if ( isWalkableForHumans(current.x+1, current.y)) {                                                                             //see above
        temp = wObjectsInLevel[current.x+1][current.y];
        if (!(visited.contains(temp)) && isWalkableForHumans(temp.x, temp.y)) {
          adjacent.add(temp);
          previous.put(temp, current);
        }
      }

      //check south
      if ( isWalkableForHumans(current.x, current.y+1)) {                                                                             //see above
        temp = wObjectsInLevel[current.x][current.y+1];
        if (!(visited.contains(temp)) && isWalkableForHumans(temp.x, temp.y)) {
          adjacent.add(temp);
          previous.put(temp, current);
        }
      }

      //check west
      if ( isWalkableForHumans(current.x-1, current.y)) {                                                                             //see above
        temp = wObjectsInLevel[current.x-1][current.y];
        if (!visited.contains(temp)) {
          adjacent.add(temp);
          previous.put(temp, current);
        }
      }
      visited.add(current);                                                                                                         //add current tile to the visited list
    }

    goal = getNewGoal(destination.x, destination.y);                                                                                //unreachable goalPosition unreachable from current Position, set a new goalPosition.
    nextX = current.x;
    nextY = current.y;
  }

  /*
  goes along the predecessors from the destination to the start
   */
  public WorldObject backtrack(HashMap <WorldObject, WorldObject> previous, WorldObject destination) {
    WorldObject temp;
    temp = destination;
    try {
      while (!(previous.get(temp).x == posX && previous.get(temp).y == posY)) {    //keep finding the previous tile until arriving at the tile next to the starting tile.
        temp = previous.get(temp);
      }
      return temp;
    } 
    catch (Exception e) {
      return temp;
    }
  } 

  /*
  move to the next tile, if there is a door in the way open it
   */
  public void goToNext() {
    if (wObjectsInLevel[nextX][nextY] instanceof DoorPiece) {
      ((DoorPiece)wObjectsInLevel[nextX][nextY]).act();
    }
    posX = nextX;
    posY = nextY;
  }

  /*
  gets called by the noiseItem, triggers HEARD_NOISE_ITEM
   */
  public void reactToNoise(WorldObject noise, WorldObject neighbour) {
    if (reactsToNoiseItem && millis()-lastNoiseAlert >= NOISE_COOLDOWN) {
      lastNoiseAlert = millis();
      state = HEARD_NOISE_ITEM;
      goal = neighbour;
      noiseItem = noise;
      stateStartTime  = millis();
    }
  }

  /*
  chooses one of the goals in goals[][] as new destination
   */
  public WorldObject getNewGoal(int oldGoalX, int oldGoalY) {
    byte random;
    int x;
    int y;
    do {
      random  = (byte)round(random(-0.499f, 2.499f));
    } while (goals[random][0] == oldGoalX && goals[random][1] == oldGoalY);
    x = goals[random][0];                              
    y = goals[random][1];
    return wObjectsInLevel[x][y];
  }
}
class Alien extends GameCharacter {

  char whichAlien;                          //Which alien is it? 1 or 2
  boolean canPressButton;

  int posX;                                 //position
  int posY;
  boolean inGoal;                           //after all ufo pieces are found, aliens need to be in the goal Tile


  Alien(int _posX, int _posY, char _whichAlien) {
    characterID = super.characterID;

    whichAlien = _whichAlien;
    if (whichAlien == '1') {
      canPressButton = true;
    } else {
      canPressButton = false;
    }

    posX = _posX;
    posY = _posY;

    inGoal = false;
  }

  public void draw() {
    wObjectsInLevel[posX][posY].draw();      //draw object underneath the alien
    if (whichAlien == '1') {                 //then the alien
      image(alien1Img, posX, posY, 1, 1);
    } else {
      image(alien2Img, posX, posY, 1, 1);
    }
  }

  /*
  GameRunningMode calls recieveInput, decides the action dependend on the position & alien
   */
  public void recieveInput(int _x, int _y) {
    int nextX = posX + _x;
    int nextY = posY + _y;

    if ((nextX < NUM_TILES_X) && (nextX >= 0) && (nextY < NUM_TILES_Y) && (nextY >= 0)) {                                                  // in bounds?

      if (wObjectsInLevel[nextX][nextY] instanceof InteractiveWorldObject && !(wObjectsInLevel[nextX][nextY] instanceof DoorPiece)) {      // interact with InteractiveWorldObjects that aren't just for humans (= doors)
        InteractiveWorldObject object = (InteractiveWorldObject)wObjectsInLevel[nextX][nextY];

        if (!(object instanceof Button)) {                                                                                                 // interact with objects directly (not with buttons)
          if (object instanceof Box) {
            if (this.whichAlien == '2') {
              Box b = (Box) object;
              b.tryMoving(_x, _y);
            }
          } else {
            object.act();
          }
        }
      }

      if (wObjectsInLevel[nextX][nextY].walkable) {                                                                                       // check if walkable (= non-interactive objects or buttons)
        if (wObjectsInLevel[nextX][nextY] instanceof Ground) {                                                                            // move if ground is walkable for aliens
          Ground g = (Ground) wObjectsInLevel[nextX][nextY];

          if (g.onlyHumans) {                                        //funtionality for a planned level
            // don't move
          } else {
            interactWithButton(nextX, nextY);                                                                                    // button acts when alien 2 walks off
            move(nextX, nextY);
          }
        } else {                                                                                                                          // button acts when alien 2 walks on
          interactWithButton(nextX, nextY);         
          move(nextX, nextY);
        }
      }
      if (wObjectsInLevel[nextX][nextY] instanceof Wall) {                                                                                // move if alien 1 is trying to go through a wall with hole
        Wall w = (Wall) wObjectsInLevel[nextX][nextY];
        if (w.hasSmallHole && this.whichAlien == '1') {
          move(nextX, nextY);
        }
      }
    }
  }

  /*
  moves the alien to the next Tile
   */
  public void move(int nextX, int nextY) {
    redrawBG(posX, posY);
    posX = nextX;
    posY = nextY;

    if (grm.allUfoPiecesCollected) {                                                             // when all UfoPieces are collected, check if the alien is in the goal
      if (posX == goalX1 || posX == goalX2) {
        if (posY == goalY1 || posY == goalY2) {
          inGoal = true;
        } else {
          inGoal = false;
        }
      } else {
        inGoal = false;
      }
    }
  }

  /* 
   checks if alien 2 walked on or off a button and acts accordingly 
   */
  public void interactWithButton(int nextX, int nextY) {
    if (this.whichAlien == '2') {
      if (wObjectsInLevel[posX][posY] instanceof Button) {
        Button b = (Button) wObjectsInLevel[posX][posY];
        b.act();
      } else if (wObjectsInLevel[nextX][nextY] instanceof Button) {
        Button b = (Button) wObjectsInLevel[nextX][nextY];
        b.act();
      }
    }
  }
}
java.util.LinkedList<DoorPiece> doorPieces = new java.util.LinkedList();

// builds door out of correct DoorPieces
class DoorMaker extends WorldObject {
  int doorID;
  String whichGround;

  DoorMaker(int _x, int _y, int _doorID, String _whichObject, String _whichGround) {
    x = _x;
    y = _y;
    whichObject = _whichObject;
    doorID = _doorID;
    whichGround = _whichGround;
  }
  //---------------------------------------------------------

  public void buildDoor() {
    switch (whichObject) {
    case "garden gate":
      wObjectsInLevel[x][y] = new DoorPiece(x, y, doorID, "garden gate post", whichGround);
      wObjectsInLevel[x+3][y] = new DoorPiece(x+3, y, doorID, "garden gate post", whichGround);
      wObjectsInLevel[x][y-3] = new DoorPiece(x, y-3, doorID, "garden gate post", whichGround);
      wObjectsInLevel[x+1][y] = new DoorPiece(x+1, y, doorID, "garden gate left", whichGround);
      wObjectsInLevel[x+2][y] = new DoorPiece(x+2, y, doorID, "garden gate right", whichGround);
      break;
    case "barrier":
      wObjectsInLevel[x][y] = new DoorPiece(x, y, doorID, "barrier left", whichGround);
      for (int i = 1; i <= 4; i++) {
        wObjectsInLevel[x+i][y] = new DoorPiece(x+i, y, doorID, "barrier middle", whichGround);
      }
      wObjectsInLevel[x+5][y] = new DoorPiece(x+5, y, doorID, "barrier right", whichGround);
      break;
    case "door":
      wObjectsInLevel[x][y] = new DoorPiece(x, y, doorID, "door corner", whichGround);
      wObjectsInLevel[x][y-1] = new DoorPiece(x, y-1, doorID, "door bottom", whichGround);
      wObjectsInLevel[x][y-2] = new DoorPiece(x, y-2, doorID, "door top", whichGround);      
      break;
    }
  }
}
//---------------------------------------------------------


// door has to be made out of several object, each with their own x and y coordinates for humans to be able to walk through them
class DoorPiece extends InteractiveWorldObject {
  boolean originalState;                  // door can have 2 states
  String whichGround;                     // which type of ground would theoretically lie unnder the door
  boolean humanCanOpen;
  int doorID;                             // which door the piece belongs to
  boolean acted;
  int timeLastActed = timeOutTime;        // door can only act once every second 

  DoorPiece(int _x, int _y, int _doorID, String _whichObject, String _whichGround) {
    doorPieces.add(this);
    x = _x;
    y = _y;
    walkable = false;
    originalState = true;
    whichObject = _whichObject;
    whichGround = _whichGround;
    doorID = _doorID;
    acted = false;

    switch (whichObject) {
      // garden gate
    case "garden gate post":
      humanCanOpen = false;
      break;
    case "garden gate left":
      humanCanOpen = true;
      break;
    case "garden gate right":
      humanCanOpen = true;
      break;
      // barrier
    case "barrier left":
      humanCanOpen = false;
      break;
    case "barrier middle":
      humanCanOpen = false;
      break;
    case "barrier right":
      humanCanOpen = false;
      break;
      // door
    case "door corner":
      humanCanOpen = false;
      break;
    case "door top":
      humanCanOpen = true;
      break;
    case "door bottom":
      humanCanOpen = true;
      break;
    }
  }
  //---------------------------------------------------------

  public void draw() {
    switch (whichObject) {
      // garden gate
    case "garden gate post":
      fill(0xffa99173);
      ellipseMode(CORNER);
      circle(x, y, 1);
      break;
    case "garden gate left":
      image(gardenGateLeftImg, x, y, 1, 1);
      break;
    case "garden gate right":
      image(gardenGateRightImg, x, y, 1, 1);
      break;
    case "garden gate top":
      image(gardenGateTopImg, x, y, 1, 1);
      break;
    case "garden gate bottom":
      image(gardenGateBottomImg, x, y, 1, 1);
      break;
      // barrier
    case "barrier left":
      image(barrierLeftImg, x, y, 1, 1);
      break;
    case "barrier middle":
      image(barrierMiddleImg, x, y, 1, 1);
      break;
    case "barrier right":
      image(barrierRightImg, x, y, 1, 1);
      break;
      // door
    case "door corner":
      fill(31, 30, 28);
      ellipseMode(CORNER);
      circle(x, y, 1);
      rectMode(CORNER);
      rect(x, y, 0.5f, 0.5f);
      rect(x, y+0.5f, 1, 0.5f);
      break;
    case "door top":
      image(doorTopImg, x, y, 1, 1);
      break;
    case "door bottom":
      image(doorBottomImg, x, y, 1, 1);
      break;
    case "door left":
      image(doorLeftImg, x, y, 1, 1);
      break;
    case "door right":
      image(doorRightImg, x, y, 1, 1);
      break;
    }

    if (timeLastActed > timer) {
      acted = false;
    }
  }
  //---------------------------------------------------------

  public void act() {
    if (!acted) {
      // from original state to other
      if (originalState) {
        originalState = false;
        fill(grm.world.bg);                // color for redrawing the background on changing tiles
        rectMode(CORNER);
        switch (whichObject) {
          // garden gate
        case "garden gate left":
          wObjectsInLevel[x][y] = new Ground(x, y, whichGround);
          rect(x, y, 1, 1);
          x = x-1;
          y = y-1;
          whichObject = "garden gate bottom";
          wObjectsInLevel[x][y] = this;
          break;
        case "garden gate right":
          wObjectsInLevel[x][y] = new Ground(x, y, whichGround);
          rect(x, y, 1, 1);
          x = x-2;
          y = y-2;
          whichObject = "garden gate top";
          wObjectsInLevel[x][y] = this;
          break;
          // barrier
        case "barrier left":
          wObjectsInLevel[x][y] = new Ground(x, y, whichGround);
          wObjectsInLevel[x+1][y] = new Ground(x+1, y, ((DoorPiece) wObjectsInLevel[x+1][y]).whichGround);
          rect(x, y, 1, 1);
          rect(x+1, y, 1, 1);
          x = x+2;
          wObjectsInLevel[x][y] = this;
          break;
        case "barrier middle": 
          rect(x, y, 1, 1);
          x = x+2;
          wObjectsInLevel[x][y] = this;
          break;
        case "barrier right": 
          rect(x, y, 1, 1);
          x = x+2;
          wObjectsInLevel[x][y] = this;
          break;
          // door
        case "door top":
          wObjectsInLevel[x][y] = new Ground(x, y, whichGround);
          rect(x, y, 1, 1);
          x = x+2;
          y = y+2;
          whichObject = "door right";
          wObjectsInLevel[x][y] = this;
          break;
        case "door bottom":
          wObjectsInLevel[x][y] = new Ground(x, y, whichGround);
          rect(x, y, 1, 1);
          x = x+1;
          y = y+1;
          whichObject = "door left";
          wObjectsInLevel[x][y] = this;
          break;
        default:
          // do nothing
        }
      } 
      // from other state to original
      else {
        originalState = true;
        fill(grm.world.bg);                  // color for redrawing the background on changing tiles
        rectMode(CORNER);
        switch (whichObject) {
          // garden gate
        case "garden gate bottom":
          wObjectsInLevel[x][y] = new Ground(x, y, whichGround);
          rect(x, y, 1, 1);
          x = x+1;
          y = y+1;
          whichObject = "garden gate left";
          wObjectsInLevel[x][y] = this;
          break;
        case "garden gate top":
          wObjectsInLevel[x][y] = new Ground(x, y, whichGround);
          rect(x, y, 1, 1);
          x = x+2;
          y = y+2;
          whichObject = "garden gate right";
          wObjectsInLevel[x][y] = this;
          break;
          // barrier
        case "barrier left":
          rect(x, y, 1, 1);
          x = x-2;
          wObjectsInLevel[x][y] = this;
          break;
        case "barrier middle":
          rect(x, y, 1, 1);
          x = x-2;
          wObjectsInLevel[x][y] = this;
          break;
        case "barrier right":
          wObjectsInLevel[x][y] = new Ground(x, y, whichGround);
          wObjectsInLevel[x-1][y] = new Ground(x-1, y, ((DoorPiece) wObjectsInLevel[x-1][y]).whichGround);
          rect(x, y, 1, 1);
          rect(x-1, y, 1, 1);
          x = x-2;
          wObjectsInLevel[x][y] = this;
          break;
          // door
        case "door right":
          wObjectsInLevel[x][y] = new Ground(x, y, whichGround);
          rect(x, y, 1, 1);
          x = x-2;
          y = y-2;
          whichObject = "door top";
          wObjectsInLevel[x][y] = this;
          break;
        case "door left":
          wObjectsInLevel[x][y] = new Ground(x, y, whichGround);
          rect(x, y, 1, 1);
          x = x-1;
          y = y-1;
          whichObject = "door bottom";
          wObjectsInLevel[x][y] = this;
          break;
        default:
          // do nothing
        }
      }

      timeLastActed = millis();
      acted = true;

      // other pieces of the same door act too
      for (int i = 0; i < doorPieces.size(); i++) {
        if (doorPieces.get(i) != this && doorPieces.get(i).doorID == this.doorID) {
          doorPieces.get(i).act();
        }
      }
    }
  }
}
boolean whichCreditsPage = false;

class GameCreditsMode extends GameMode {

  PImage credits1;
  PImage credits2;

  public GameCreditsMode(Game game, ControlP5 cp5, UI ui) {
    super(game, cp5, ui);
    ModeName = "GameCreditsMode";
    credits1 = loadImage("screens/credits_01.png");
    credits2 = loadImage("screens/credits_02.png");
  }


  public void start(boolean fromLevel2) {
    ui.updateUI();
    whichCreditsPage = false;
    if (whichCreditsPage) {
      page2Button.setImage(page2ButtonImage);
    } else {
      page2Button.setImage(page1ButtonImage);
    }
  }

  public void drawGame() {
    background(0);
    if (whichCreditsPage) {
      image(credits2, 0, 0);
    } else {
      image(credits1, 0, 0);
    }
    Stars();
  }

  public void Stars() {
    randomSeed(1337);
    for (int star = 0; star < 1500; star++) {
      float h = noise(frameCount / 30.3f + star) * 255;
      point(random(0, width), random(0, height));
      stroke(h);
    }
  }
}

public void Menu() {
  MainGame.currentGameMode = MainGame.homeMode;
  MainGame.currentGameMode.start(false);
}

public void CreditsToggel() {
  whichCreditsPage = !whichCreditsPage;
  if (whichCreditsPage) {
    page2Button.setImage(page2ButtonImage);
  } else {
    page2Button.setImage(page1ButtonImage);
  }
}
class GameLostMode extends GameMode {

  PImage lostModeImage;

  public GameLostMode(Game game, ControlP5 cp5, UI ui) {
    super(game, cp5, ui);
    ModeName = "GameLostMode";
    MainGame = game;
    lostModeImage = loadImage("screens/screen_lost_01.png");
  }

  public void start(boolean fromLevel2) {
    ui.updateUI();
    rectMode(CORNER);
    fill(0, 150);
    rect(0, 0, width, height);
  }

  public void drawGame() {
    image(lostModeImage, 0, 0);
  }

  public void Stars() {
    randomSeed(1337);
    for (int star = 0; star < 1500; star++) {
      float h = noise(frameCount / 30.3f + star) * 255;
      point(random(0, width), random(0, height));
      stroke(h);
    }
  }
}

public void showButton() {
}

public void TryAgain() {
  MainGame.currentGameMode = MainGame.homeMode;
  MainGame.currentGameMode.start(false);
}
Game MainGame;

abstract class GameMode {

  //game class functions as connection between Modes and classes
  Game game;
  public ControlP5 cp5;
  String ModeName;
  UI ui;


  public GameMode(Game game, ControlP5 cp5, UI ui) {
    this.game = game;
    this.cp5 = cp5;
    MainGame = game;
    this.ui = ui;
    start(false);
  }

  public abstract void start(boolean fromLevel2);

  public abstract void drawGame();
}


boolean[] keys = new boolean[255];
int movmentTimerP1 = 0;
int movmentTimerP2 = 0;
int movmentThreshold = 1;
int timer;
int timeOutTime = 120;
int maxUfoPieces;

float lastMoved = 0;
boolean move = true;
final float MOVEMENT_COOLDOWN = 600;

class GameRunningMode extends GameMode {

  public World world;
  float deltaTime;
  float startTime = 0;
  public int counter = 0;
  PGraphics pg = createGraphics(100, 50);
  boolean allUfoPiecesCollected;
  float goalAlpha = 1;
  boolean goalAlphaDeclining = false;
  float goalAnimationSpeed = 30;
  PImage imgGoal = loadImage("levels/goal.png");
  PFont font = createFont("font/lithospro-regular.otf", 40);

  public GameRunningMode(Game game, ControlP5 cp5, UI ui) {
    super(game, cp5, ui);
    ModeName = "GameRunningMode";
  }

  public void start(boolean fromLevel2) {
    ui.updateUI();

    movmentTimerP1 = movmentThreshold + 1;
    movmentTimerP2 = movmentThreshold + 1;

    timer = timeOutTime;
    startTime = millis() / 1000;
    counter = 0;
  }

  //Timer
  public void time() {
    deltaTime =  (millis() / 1000) - startTime ;

    if (timer > 0 ) {
      float currentTimer = timeOutTime - deltaTime;
      timer = (int) currentTimer +1;
    } else {
      MainGame.currentGameMode = MainGame.glm;
      MainGame.currentGameMode.start(false);
    }

    //Timer with Background so it doesn't get overwritten by world
    pushMatrix();
    String _timer = " " + timer;
    pg.beginDraw();
    if (timer >= 20) {
      pg.background(world.bg);
    } else {
      pg.background(0xffFF0000);
    }
    pg.fill(245, 227, 154);
    pg.textFont(font);
    pg.textAlign(CENTER, CENTER);
    pg.text(_timer, 40, 20);
    pg.endDraw();
    image(pg, 0, 0, 4, 2);
    popMatrix();
    //---------------------------------------------------------
  }
  //---------------------------------------------------------


  public void addUfoPiece() {
    counter += 1;
    if (counter >= maxUfoPieces) {
      allUfoPiecesCollected = true;
    }
  }

  public void drawCounter() {
    pushMatrix();
    translate(0, 2);
    pg.beginDraw();
    pg.background(world.bg);
    pg.fill(245, 227, 154);
    pg.textFont(font);
    pg.textAlign(CENTER, CENTER);
    pg.text("C: " + counter, 50, 20);
    pg.endDraw();
    image(pg, 0, 0, 4, 2);
    popMatrix();
  }

  public void showGoal() {
    fill(0xff148B06);
    rectMode(CORNER);
    rect(goalX1, goalY1, 1, 1);
    rect(goalX2, goalY2, 1, 1);
    if (goalAlpha >= 255) {
      goalAlphaDeclining = true;
    } else if (goalAlpha <= 10) {
      goalAlphaDeclining = false;
    }
    if (goalAlphaDeclining) {
      goalAlpha -= goalAnimationSpeed;
    } else {
      goalAlpha += goalAnimationSpeed;
    }
    tint(255, goalAlpha);
    image (imgGoal, goalX1, goalY1, 1, 1);
    image (imgGoal, goalX2, goalY2, 1, 1);
    noTint();
  }

  public boolean aliensInGoal() {
    if (alien1.inGoal && alien2.inGoal) {
      return true;
    } else {
      return false;
    }
  }


  PVector alien1Input = new PVector(0, 0);
  PVector alien2Input = new PVector(0, 0);

  //Creates World, Player, KI
  public void drawGame() {
    world.resetLitTiles();

    world.draw();

    //Condition that if Alines collected all UfoPieces they have to get to finsih line which will appear after condition is true
    if (allUfoPiecesCollected) {
      showGoal();
    }
    //---------------------------------------------------------

    // draw and move humans
    if (!move && millis()-lastMoved >= MOVEMENT_COOLDOWN) {
      move = true;
      lastMoved = millis();
    }
    for (Human human : humans) {
      if (move) {
        human.move();
      }
      human.draw();
    }
    move = false;
    //---------------------------------------------------------

    // alien movement and draw
    alien1Input.x = 0;
    alien1Input.y = 0;

    alien2Input.x = 0;
    alien2Input.y = 0;

    for (int i = 0; i < 255; i++) {
      //Array saves every key to detect if pressed key is in it and requiers action
      if (keys[i]) { 
        if (i == 87 ) { 
          alien1Input.y = - 1;
          movmentTimerP1 = 0;
        }
        if (i == 65) { 
          alien1Input.x = - 1;
          movmentTimerP1 = 0;
        }
        if (i == 83 ) { 
          alien1Input.y = 1;
          movmentTimerP1 = 0;
        }
        if (i == 68) { 
          alien1Input.x = 1;
          movmentTimerP1 = 0;
        }
        if (i == 38) { 
          alien2Input.y = -1;
          movmentTimerP2 = 0;
        }
        if (i == 40) { 
          alien2Input.y = 1;
          movmentTimerP2 = 0;
        }
        if (i == 37) { 
          alien2Input.x = -1;
          movmentTimerP2 = 0;
        }
        if (i == 39) {
          alien2Input.x = 1;
          movmentTimerP2 = 0;
        }
      }
    }
    //---------------------------------------------------------

    alien1Input.normalize();
    alien2Input.normalize();
    if (alien1Input.x != 0 || alien1Input.y != 0) {
      alien1.recieveInput((int) alien1Input.x, (int) alien1Input.y);
    }
    if (alien2Input.x != 0 || alien2Input.y != 0) {
      alien2.recieveInput((int) alien2Input.x, (int) alien2Input.y);
    }

    alien1.draw();
    alien2.draw();
    //---------------------------------------------------------

    //draw lights                                               
    for (int x = 0; x < NUM_TILES_X; x++) {
      for (int y = 0; y < NUM_TILES_Y; y++) {
        if (litTiles[x][y]) {
          rectMode(CORNER);
          fill(0xffFFFBD1, 130);
          rect(x, y, 1, 1);
        }
      }
    }
    //---------------------------------------------------------

    // check if win conditions are met
    if (allUfoPiecesCollected) {
      if (aliensInGoal()) {
        MainGame.currentGameMode = MainGame.gwm;
        if (world.level == 3) {
          MainGame.currentGameMode.start(true);
        } else {
          MainGame.currentGameMode.start(false);
        }
      }
    }
    //---------------------------------------------------------

    time();
    drawCounter();
  }
  //---------------------------------------------------------
}

public void keyPressed() {
  if (currentGameMode == gtm ) {
    startLevel(1);
  }
  if (keyCode >= keys.length || keyCode < 0) {
    return;
  }

  keys[keyCode] = true;

  if (keyCode == 87 || keyCode == 65 || keyCode == 83 || keyCode == 68) {
    movmentTimerP1++;
  } else {
    movmentTimerP1 = movmentThreshold + 1;
  }
  if (keyCode == 38 || keyCode == 40 || keyCode == 39 || keyCode == 37) {
    movmentTimerP2++;
  } else {
    movmentTimerP2 = movmentThreshold + 1;
  }
}

public void keyReleased() {
  if (keyCode >= keys.length || keyCode < 0) {
    return;
  }
  keys[keyCode] = false;

  if (keyCode == 87 || keyCode == 65 || keyCode == 83 || keyCode == 68) {
    movmentTimerP1 = movmentThreshold + 1;
  }
  if (keyCode == 38 || keyCode == 40 || keyCode == 39 || keyCode == 37) {
    movmentTimerP2 = movmentThreshold + 1;
  }
}
class GameTutorialMode extends GameMode {

  PImage tutorial;
  
  //Shows Tutorial Screen
  public GameTutorialMode(Game game, ControlP5 cp5, UI ui) {
    super(game, cp5, ui);
    ModeName = "GameTutorialMode";
    tutorial = loadImage("screens/tutorial_01.png");
  }


  public void start(boolean fromLevel2) {
    ui.updateUI();
  }

  public void drawGame() {
    background(0);
    image(tutorial, 0, 0);
    Stars();
    
  }

  public void Stars() {
    randomSeed(1337);
    for (int star = 0; star < 1500; star++) {
      float h = noise(frameCount / 30.3f + star) * 255;
      point(random(0, width), random(0, height));
      stroke(h);
    }
  }
}
class GameWonMode extends GameMode {

  PImage wonModeImage;

  public GameWonMode(Game game, ControlP5 cp5, UI ui) {
    super(game, cp5, ui);
    ModeName = "GameWonMode";

    MainGame = game;
    wonModeImage = loadImage("screens/screen_won_01.png");
  }


  public void start(boolean _fromLevel2) {
    ui.updateUI();
    fromLevel2 = _fromLevel2;
  }

  public void drawGame() {
    background(0);
    Stars();
    image(wonModeImage, 0, 0);
  }


  public void Stars() {
    randomSeed(1337);
    for (int star = 0; star < 1500; star++) {
      float h = noise(frameCount / 30.3f + star) * 255;
      point(random(0, width), random(0, height));
      stroke(h);
    }
  }
}

boolean fromLevel2; //shows wich Level is won to actived Credits after the final level

public void Back() {
  if (fromLevel2 == false) {
    MainGame.currentGameMode = MainGame.homeMode;
    MainGame.currentGameMode.start(false);
  } else {
    MainGame.currentGameMode = MainGame.gcm;
    MainGame.currentGameMode.start(false);
  }
}
class Ground extends WorldObject {
  boolean onlyAliens = false;
  boolean onlyHumans = false;
  int tint;

  Ground(int _x, int _y, String _whichObject) {
    x = _x;
    y = _y;
    tint = round(random(220, 255));

    whichObject = _whichObject;
    // load correct image
    switch (whichObject) {
    case "street":                // not in use, part of original level 2
      onlyAliens = true;
      break;
    case "footpath":              // not in use, part of original level 2
      onlyHumans = true;
      break;
    }
    walkable = true;
  }
  //---------------------------------------------------------

  public void draw() {
    // draw correct ground image
    imageMode(CORNER);
    switch (whichObject) {
    case "leaves":
      tint(tint);
      image(leavesImg, x, y, 1, 1);
      noTint();
      break;
    case "street":
      image(streetImg, x, y, 1, 1);              // not in use, part of original level 2
      break;
    case "footpath":
      image(footpathImg, x, y, 1, 1);            // not in use, part of original level 2
      break;
    case "l3 ground":
      image(l3GroundImg, x, y, 1, 1);
      break;
    case "carpet":
      image(carpetImg, x, y, 1, 1);
      break;
    case "carpet top left":
      image(carpetTopLeftImg, x, y, 1, 1);
      break;
    case "carpet top right":
      image(carpetTopRightImg, x, y, 1, 1);
      break;
    case "carpet bottom left":
      image(carpetBottomLeftImg, x, y, 1, 1);
      break;
    case "carpet bottom right":
      image(carpetBottomRightImg, x, y, 1, 1);
      break;
    case "carpet side top":
      image(carpetSideTopImg, x, y, 1, 1);
      break;
    case "carpet side bottom":
      image(carpetSideBottomImg, x, y, 1, 1);
      break;
    }
  }
}

Game _game;
GameWonMode won;
GameLostMode lost;

//Contains Menu, Background and Ufo Animation
class HomeMode extends GameMode {

  PImage ufoAnim = loadImage("assets/ufo_02.png");
  PVector ufoPos = new PVector(150, 150);
  PVector direction = new PVector(1f, 1f);
  float velocity = 2.5f;
  float ufoRadius = 100;

  public HomeMode(Game game, ControlP5 cp5, UI ui) {    
    super(game, cp5, ui);
    _game = game;
    ModeName = "HomeMode";
    direction.mult(velocity);
    ufoPos.x = random(1, width - ufoRadius -1);
    ufoPos.y = random(1, height - ufoRadius -1);
  }

  public void start(boolean fromLevel2) {
    if (ui != null) {
      ui.updateUI();
    }
    background(0);
    if (ufoPos != null) {
      ufoPos.x = random(1, width - ufoRadius -1);
      ufoPos.y = random(1, height - ufoRadius -1);
    }
  }

  public void drawGame() {
    background(0);
    Stars();
    UfoAnimation();
  }

  public void Stars() {
    randomSeed(1337);
    for (int star = 0; star < 1500; star++) {
      float h = noise(frameCount / 30.3f + star) * 255;
      point(random(0, width), random(0, height));
      stroke(h);
    }
  }

  public void UfoAnimation() {
    ufoAnim.resize(100, 100);
    ufoPos.add(direction);
    image(ufoAnim, ufoPos.x, ufoPos.y);

    //Collions Detection
    if (ufoPos.x > width - ufoRadius || ufoPos.x < 0 || ufoPos.y > height - ufoRadius || ufoPos.y < 0) {
      if (ufoPos.y > height - ufoRadius) {
        direction.y *= -1;
      }
      if (ufoPos.y < 0) {
        direction.y *= -1;
      }
      if (ufoPos.x > width - ufoRadius) {
        direction.x *= -1;
      }
      if (ufoPos.x < 0) {
        direction.x *= -1;
      }
    }
    //---------------------------------------------------------
  }
}

//Function of Buttons
public void Level_1() {
  _game.currentGameMode = gtm;
  _game.currentGameMode.start(false);
}

public void Level_2() {
  startLevel(3);
}
public void Credits() {
  _game.currentGameMode = gcm;
  _game.currentGameMode.start(false);
}

public void Exit() {
  exit();
}

//---------------------------------------------------------


//Starts correct Level
public void startLevel(int levelIndex) {
  _game.currentGameMode = grm;
  _game.currentGameMode.start(false);
  World newWorld = new World(levelIndex); 
  grm.world = newWorld;
}
//------------------------------------------------------
class Lamp extends InteractiveWorldObject {
  boolean on;
  int radius = 3;
  boolean [][] litByLamp = new boolean [NUM_TILES_X][NUM_TILES_Y];
  int timeLastActed = timeOutTime;
  AudioPlayer lampNoise = minim.loadFile("sound/zapsplat_household_light_switch_garage_flick_001_53168.mp3");

  Lamp(int _x, int _y, String _whichObject) {
    x = _x;
    y = _y;
    walkable = false;
    whichObject = _whichObject;
    on = true;
  }
  //---------------------------------------------------------

  public void draw() {
    imageMode(CORNER);
    image(lampImg, x, y, 1, 1);

    fov();
    lightTiles();
  }
  //---------------------------------------------------------

  /*
  fills the litByLamp array with tiles that are lit by the lamp. They are based on the radius and the surrounding geometry
  see fov() in Human class
   */
  public void fov() {
    // reset array
    for (int i= 0; i<NUM_TILES_X; i++) {                              
      for (int j = 0; j<NUM_TILES_Y; j++) {
        litByLamp[i][j] = false;
      }
    }

    float endOfLineX;
    float endOfLineY;
    final float DEG_RAD_CONV = PI/180; 

    if (on) {
      for (int i = 0; i < 360; i += 15) {
        float deg = i*DEG_RAD_CONV;

        endOfLineX = (cos(deg) * radius) + x;                      // lines to endpoints
        endOfLineY = (sin(deg) * radius) + y;

        int d = round(dist(x, y, endOfLineX, endOfLineY));

        for (int j = 0; j < d; j++) {
          int tileX = round(lerp(x, endOfLineX, j/(float)d));      // interpolate along the lines
          int tileY = round(lerp(y, endOfLineY, j/(float)d));        

          if (tileX < 0 || tileX >= NUM_TILES_X) {                 // check bounds
            continue;
          }    
          if (tileY < 0 || tileY >= NUM_TILES_Y) {
            continue;
          }

          if (!wObjectsInLevel[tileX][tileY].walkable) {           // if you hit a wall, door or other, dont continue
            // Lamp and NoiseItem are exceptions
            if (wObjectsInLevel[tileX][tileY] instanceof Lamp || wObjectsInLevel[tileX][tileY] instanceof NoiseItem) {
            } else {
              break;
            }
          }
          litByLamp[tileX][tileY] = true;
        }
      }
    }
  }
  //---------------------------------------------------------

  public void lightTiles() {
    for (int i= 0; i<NUM_TILES_X; i++) {                              
      for (int j = 0; j<NUM_TILES_Y; j++) {
        if (!litTiles[i][j]) {
          litTiles[i][j] = litByLamp[i][j];
        }
      }
    }
  }
  //---------------------------------------------------------

  public void act() {
    if (timeLastActed > timer) {
      if (on) {
        on = false;
        for (int i= 0; i<NUM_TILES_X; i++) {                              
          for (int j = 0; j<NUM_TILES_Y; j++) {
            litByLamp[i][j] = false;
          }
        }
      } else {
        on = true;
      }
      timeLastActed = timer;

      this.lampNoise.rewind();
      this.lampNoise.play();
    }
  }
}
int doorIDCounter = 0;

class LevelEditor {

  PImage level1;
  PImage level2;
  PImage level3;

  int tilesX = 42;
  int tilesY = 28;

  public LevelEditor(int level) {
    level1 = loadImage("levels/level_01.png");
    level2 = loadImage("levels/level_02.png");
    level3 = loadImage("levels/level_03.png");
    colorMode(RGB);
    readPixel(level);
  }
  //goes through all Tiles to detect color of each pixel
  public void readPixel(int level) {

    // reset numer of UfoPieces in Level to 0
    maxUfoPieces = 0;

    int c = color(0);
    for (int x = 0; x < tilesX; x++) {
      for (int y = 0; y < tilesY; y++) {
        switch(level) {
        case 1:
          c = level1.get(x, y);
          break;
        case 2:
          c = level2.get(x, y);
          break;
        case 3:
          c = level3.get(x, y);
          break;
        }
        drawObjectsLevel(red(c), green(c), blue(c), x, y);
      }
    }
    addButtons(level);
  }

  //draws Level (RGB colors, x/y Positions, Level)
  //gets Value from readPixel decides which png belongs to which Tile
  public void drawObjectsLevel(float r, float g, float b, int x, int y) {
    if (r == 100 && g == 100 && b == 100) {
      wObjectsInLevel[x][y] = new Ground(x, y, "street");
    }
    if (r == 35 && g == 35 && b == 35) {
      wObjectsInLevel[x][y] = new Ground(x, y, "footpath");
    }
    if (r == 0 && g == 255 && b == 0) {
      wObjectsInLevel[x][y] = new Wall(x, y, "tree");
    }
    if (r == 175 && g == 100 && b == 0) {
      wObjectsInLevel[x][y] = new Wall(x, y, "housewall");
    }
    if (r == 100 && g == 130 && b == 100) {
      wObjectsInLevel[x][y] = new Wall(x, y, "ufo");
      // same ufo on these tiles
      for (int i = 0; i < 6; i++) {
        for (int j = 0; j < 5; j++) {
          wObjectsInLevel[x+i][y+j] = wObjectsInLevel[x][y];
        }
      }
    }
    if (r == 130 && g == 50 && b == 50) {
      wObjectsInLevel[x][y] = new Wall(x, y, "roof");
    }
    if (r == 0 && g == 100 && b == 50) {
      wObjectsInLevel[x][y] = new NoiseItem(x, y, "tv");
    }
    // Wall with hole
    if (r == 100 && g == 100 && b == 0) {
      wObjectsInLevel[x][y] = new Wall(x, y, "bush");
    }
    if (r == 175 && g == 175 && b == 0) {
      wObjectsInLevel[x][y] = new Wall(x, y, "wall with hole");
    }
    if (r == 0 && g == 150 && b == 100) {
      wObjectsInLevel[x][y] = new Wall(x, y, "plant");
    }
    if (r == 255 && g == 0 && b == 0) {
      wObjectsInLevel[x][y] = new DoorMaker(x, y, doorIDCounter, "garden gate", wObjectsInLevel[x][y].whichObject);
      DoorMaker dm = (DoorMaker) wObjectsInLevel[x][y];
      dm.buildDoor();
      doorIDCounter++;
    }
    if (r == 255 && g == 100 && b== 100) {
      wObjectsInLevel[x][y] = new DoorMaker(x, y, doorIDCounter, "barrier", wObjectsInLevel[x][y].whichObject);
      DoorMaker dm = (DoorMaker) wObjectsInLevel[x][y];
      dm.buildDoor();
      doorIDCounter++;
    }
    if (r == 0 && g == 0 && b == 100) {
      wObjectsInLevel[x][y] = new DoorMaker(x, y, doorIDCounter, "door", wObjectsInLevel[x][y].whichObject);
      DoorMaker dm = (DoorMaker) wObjectsInLevel[x][y];
      dm.buildDoor();
      doorIDCounter++;
    }
    if (r == 0 && g == 255 && b == 255) {
      wObjectsInLevel[x][y] = new NoiseItem(x, y, "bucket");
    }
    if (r == 0 && g == 150 && b == 50) {
      wObjectsInLevel[x][y] = new Lamp(x, y, "lamp");
    }
    if (r == 0 && g == 0 && b == 255) {
      wObjectsInLevel[x][y] = new UfoPiece(x, y);
      maxUfoPieces++;
    }
    if (r == 55 && g == 44 && b == 33) {
      wObjectsInLevel[x][y] = new Box(x, y, "l3 ground");
    }
    // Tabel
    if (r == 80 && g == 100 && b == 100) {
      wObjectsInLevel[x][y] = new Wall(x, y, "tabel");
      for (int i = 0; i < 3; i++) {
        for (int j = 0; j < 2; j++) {
          wObjectsInLevel[x+i][y+j] = wObjectsInLevel[x][y];
        }
      }
    }
    if (r == 0 && g == 50 && b == 50) {
      wObjectsInLevel[x][y] = new Wall(x, y, "sofa"); 
      for (int i = 0; i < 3; i++) {
        for (int j = 0; j < 2; j++) {
          wObjectsInLevel[x+i][y+j] = wObjectsInLevel[x][y];
        }
      }
    }
    if (r == 0 && g == 100 && b == 100) {
      wObjectsInLevel[x][y] = new Ground(x, y, "carpet");
    }
    if (r == 0 && g == 71 && b == 71) {
      wObjectsInLevel[x][y] = new Ground(x, y, "carpet top left");
    }
    if (r == 0 && g == 130 && b == 130) {
      wObjectsInLevel[x][y] = new Ground(x, y, "carpet bottom left");
    }
    if (r == 0 && g == 220 && b == 220) {
      wObjectsInLevel[x][y] = new Ground(x, y, "carpet top right");
    }
    if (r == 0 && g == 190 && b == 190) {
      wObjectsInLevel[x][y] = new Ground(x, y, "carpet bottom right");
    }
    if (r == 0 && g == 160 && b == 160) {
      wObjectsInLevel[x][y] = new Ground(x, y, "carpet side top");
    }
    if (r == 0 && g == 250 && b == 250) {
      wObjectsInLevel[x][y] = new Ground(x, y, "carpet side bottom");
    }

    // Goal (Ground)
    if (r == 255 && g == 0 && b == 229) {
      if (goalX1 < 0) {
        goalX1 = x;
        goalY1 = y;
      } else if (goalX2 < 0) {
        goalX2 = x;
        goalY2 = y;
      }
    }
  }

  // adds button
  // has to be called at the end, so the objects the buttons are connected to already exist
  public void addButtons(int level) {
    switch (level) {
    case 1:
      wObjectsInLevel[11][16] = new Button(11, 16, "green button", (InteractiveWorldObject) wObjectsInLevel[14][16]);
      break;
    case 3:
      break;
    }
  }
}
// object that calls listening humans to it when acted with

class NoiseItem extends InteractiveWorldObject {
  AudioPlayer noise;
  int timeLastActed = timeOutTime;
  boolean isAlsoLamp;
  Lamp l;
  WorldObject neighbour;

  NoiseItem(int _x, int _y, String _whichObject) {
    x = _x;
    y = _y;
    whichObject = _whichObject;
    walkable = false;
    isAlsoLamp = false;
    // load correct image and sound
    switch(whichObject) {
    case "bucket":
      noise = minim.loadFile("sound/zapsplat_impact_metal_tray_tin_hit_blunt_med_pitched_resonate_ring_004_43391.mp3");
      neighbour = wObjectsInLevel[x+1][y];
      break;
    case "tv":
      noise = minim.loadFile("sound/glitched_tones_Hum+04.mp3");
      isAlsoLamp = true;
      neighbour = wObjectsInLevel[x][y-1];
      l = new Lamp(x, y, "lamp");
      l.on = false;
      break;
    }
  }
  //---------------------------------------------------------
  public void draw() {
    if (isAlsoLamp) {
      l.fov();
      l.lightTiles();
    }
    imageMode(CORNER);
    switch(whichObject) {
    case "bucket":
      image(bucketImg, x, y, 1, 1);
      break;
    case "tv":
      image(tvImg, x, y, 1, 1);
      break;
    }
  }
  //---------------------------------------------------------

  public void act() {
    // only acts once every second
    if (timeLastActed > timer) {
      if (isAlsoLamp) {
        l.act();
        if (l.on) {
          this.noise.rewind();
          this.noise.play();
        } else {
          this.noise.pause();
        }
      } else {
        this.noise.rewind();
        this.noise.play();
      }

      timeLastActed = timer;

      // tell humans that a noise was made and where
      for (Human human : humans) {
        human.reactToNoise(this, neighbour);
      }
    }
  }
}


//HomeMode Buttons
controlP5.Button level1Button;
controlP5.Button level2Button;
controlP5.Button creditsButton;
controlP5.Button exitButton;
controlP5.Button menuButton;
controlP5.Button page2Button;
//---------------------------------------

//GameLostMode
controlP5.Button backButtonLost;
//---------------------------------------

//GameWonMode
controlP5.Button backButtonWon;
//---------------------------------------

//Button Image for Credits 
PImage page2ButtonImage;
PImage page1ButtonImage;

//---------------------------------------

class UI {

  Game game;

  public UI(Game game) {
    this.game = game;
    start();
  }

  public void start() {
    createButtons();
    hideButtons();
  }

  public void createButtons() {

    //Konstruktor: String Name, Value Float, X int, Y int, Width int, Height int
    //HomeMode Buttons
    level1Button = game.cp5.addButton("Level_1", 0, width/2 - 100, height/2 - 150, 200, 50);
    level1Button.setPosition(width/2 - 100, height/2 - 150);
    PImage level1Image = loadImage("Buttons/Button_level1_01.png");
    level1Image.resize(200, 50);
    level1Button.setImage(level1Image);

    level2Button = game.cp5.addButton("Level_2", 0, width/2 - 100, height/2 - 50, 200, 50);
    level2Button.setPosition(width/2 - 100, height/2 - 50);
    PImage level2Image = loadImage("Buttons/Button_level2_01.png");
    level2Image.resize(200, 50);
    level2Button.setImage(level2Image);

    creditsButton = game.cp5.addButton("Credits", 0, width/2 - 100, height/2 + 50, 200, 50);
    creditsButton.setPosition(width/2 - 100, height/2 + 50);
    PImage creditsButtonImage = loadImage("Buttons/Button_credits_01.png");
    creditsButtonImage.resize(200, 50);
    creditsButton.setImage(creditsButtonImage);

    exitButton = game.cp5.addButton("Exit", 0, width/2 - 100, height/2 + 150, 200, 50);
    exitButton.setPosition(width/2 - 100, height/2 + 150);
    PImage exitButtonImage = loadImage("Buttons/Button_exit_01.png");
    exitButtonImage.resize(200, 50);
    exitButton.setImage(exitButtonImage);
    //----------------------------------------------------------------------------------------

    //GameWonMode Button
    backButtonWon = game.cp5.addButton("Back", 0, width/2 - 100, height/2, 200, 50);
    backButtonWon.setPosition(width/2 - 100, height/2 + 150);
    PImage backButtonImage = loadImage("Buttons/Button_Back_01.png");
    backButtonImage.resize(200, 50);
    backButtonWon.setImage(backButtonImage);
    //----------------------------------------------------------------------------------------

    //GameLostMode
    backButtonLost = game.cp5.addButton("TryAgain", 0, width/2 - 100, height/2, 200, 50);
    backButtonLost.setPosition(width/2 - 100, height/2 + 100);
    PImage lostButtonImage = loadImage("Buttons/Button_tryAgain_01.png");
    lostButtonImage.resize(200, 50);
    backButtonLost.setImage(lostButtonImage);
    //----------------------------------------------------------------------------------------

    //GameCreditsMode
    menuButton = game.cp5.addButton("Menu", 0, width/2 - 100, height/2, 200, 50);
    menuButton.setPosition(width/2 - 100, height/2 + 280);
    PImage menuButtonImage = loadImage("Buttons/Button_menu_01.png");
    menuButtonImage.resize(200, 50);
    menuButton.setImage(menuButtonImage);
    //----------------------------------------------------------------------------------------

    //GameCreditsMode
    page2Button = game.cp5.addButton("CreditsToggel", 0, width/2 - 100, height/2, 200, 50);
    page2Button.setPosition(width/2 + 300, height/2 + 280);
    page2ButtonImage = loadImage("Buttons/Button_Back_01.png");
    page1ButtonImage = loadImage("Buttons/Button_Next_01.png");
    page2ButtonImage.resize(200, 50);
    page1ButtonImage.resize(200, 50);
    page2Button.setImage(page2ButtonImage);
    //----------------------------------------------------------------------------------------
  }

  public void hideButtons() {

    //HomeMode Buttons
    level1Button.hide();
    level2Button.hide();
    creditsButton.hide();
    exitButton.hide();
    //----------------------------------------------------------------------------------------  

    //GameWonMode
    backButtonWon.hide();
    //----------------------------------------------------------------------------------------

    //GameLostMode
    backButtonLost.hide();
    //----------------------------------------------------------------------------------------

    //GameCreditsMode
    menuButton.hide();
    //----------------------------------------------------------------------------------------
    //GameCreditsMode
    page2Button.hide();
    //----------------------------------------------------------------------------------------
  }

  public void updateUI() {
    hideButtons();
    if (game.currentGameMode != null) {

      switch(game.currentGameMode.ModeName) {
      case "HomeMode":
        level1Button.show();
        level2Button.show();
        creditsButton.show();
        exitButton.show();
        break;
      case "GameWonMode":
        backButtonWon.show();
        break;
      case "GameLostMode":
        backButtonLost.show();
        break;
      case "GameRunningMode":
        hideButtons();
        break;
      case "GameTutorialMode":
        hideButtons();
        break;
      case "GameCreditsMode":
        menuButton.show();
        page2Button.show();
        break;
      }
    }
  }
}
// collectible

class UfoPiece extends InteractiveWorldObject {
  PImage imgUfoPiece;
  String whichGround;
  AudioPlayer noise;

  UfoPiece(int _x, int _y) {
    imgUfoPiece = loadImage("assets/ufopiece_01.png");
    noise = minim.loadFile("sound/zapsplat_industrial_thick_plastic_pack_of_metal_bolts_pick_up_002_53582.mp3");
    x = _x;
    y = _y;
    walkable = true;
  }
  //---------------------------------------------------------

  public void draw() {
    imageMode(CORNER);
    image(imgUfoPiece, x, y, 1, 1);
  }
  //---------------------------------------------------------

  public void act() {
    grm.addUfoPiece();
    this.noise.rewind();
    this.noise.play();

    // replace this object with ground
    for (int i = -1; i <= 1; i++) {
      for (int j = -1; j <= 1; j++) {
        if (x+i<0 || x+i>=NUM_TILES_X|| y+j<0 || y+j>=NUM_TILES_Y) {
          // skip when OOB
        } else {
          if ((wObjectsInLevel[x+i][y+j]) instanceof Ground) {
            whichGround = wObjectsInLevel[x+i][y+j].whichObject;
          }
        }
      }
    }
    wObjectsInLevel[this.x][this.y] = new Ground(this.x, this.y, this.whichGround);
  }
}
// obstacles in the level; some walls have holes that the small alien can go through

class Wall extends WorldObject {
  boolean drawn;
  int nrOfTiles;
  int countTillDraw = 0;
  boolean hasSmallHole;
  int tint;                          // for color variation of trees

  Wall(int _x, int _y, String _whichObject) {
    x = _x;
    y = _y;
    whichObject = _whichObject;
    walkable = false;
    drawn = false;
    tint = round(random(230, 255));

    switch (whichObject) {
    case "ufo":
      nrOfTiles = 30;
      hasSmallHole = false;
      break;
      // wall with hole
    case "bush":
      nrOfTiles = 1;
      hasSmallHole = true;
      break;
    case "wall with hole":
      nrOfTiles = 1;
      hasSmallHole = true;
      break;
    case "sofa":
      nrOfTiles = 6;
      hasSmallHole = false;
      break;
    case "tabel":
      nrOfTiles = 6;
      hasSmallHole = false;
      break;
    default:
      nrOfTiles = 1;
      hasSmallHole = false;
    }
  }
  //---------------------------------------------------------

  public void draw() {
    // only draw once every frame
    if (drawn) {
      if (countTillDraw == 1) {
        this.drawn = false;
      }
      countTillDraw--;
    } else {
      imageMode(CORNER);
      switch (whichObject) {
      case "tree":
        tint(tint);
        image(treeImg, x, y, 1, 1);
        noTint();
        break;
      case "ufo":
        image(ufoImg, x, y, 6, 5);
        this.drawn = true;
        countTillDraw = nrOfTiles;
        break;
        // wall with hole
      case "bush":
        image(bushImg, x, y, 1, 1);
        break;
      case "wall with hole":
        image(wallWithHoleImg, x, y, 1, 1);
        break;
      case "grass":
        image(grassImg, x, y, 1, 1);
        break;
      case "roof":
        image(roofImg, x, y, 1, 1);
        break;
      case "housewall":
        image(housewallImg, x, y, 1, 1);
        break;
      case "plant":
        image(plantImg, x, y, 1, 1);
        break;
      case "sofa":
        image(sofaImg, x, y, 3, 2); 
        this.drawn = true;
        countTillDraw = nrOfTiles;
        break;
      case "tabel":
        image(tableImg, x, y, 3, 2); 
        this.drawn = true;
        countTillDraw = nrOfTiles;
        break;
      }
    }
  }
}
public final int NUM_TILES_X = 42;
public final int NUM_TILES_Y = 28;
public final float tileWidth = (float) 1280 / NUM_TILES_X;
public final float tileHeight = (float) 720 / NUM_TILES_Y;
WorldObject wObjectsInLevel[][] = new WorldObject[NUM_TILES_X][NUM_TILES_Y];      // all objects of the level are saved in this array
boolean litTiles[][] = new boolean[NUM_TILES_X][NUM_TILES_Y];
java.util.LinkedList<Human> humans = new java.util.LinkedList();
public Alien alien1;
public Alien alien2;

// goal coordinates
int goalX1;
int goalY1;
int goalX2;
int goalY2;

GameRunningMode _grm;

class World {
  int level;
  int bg;
  String whichGround;

  World(int _level) {
    level = _level;

    switch (level) {
    case 1:
      whichGround = "leaves";
      break;
    case 3:
      whichGround = "l3 ground";
      break;
    }

    for (int x = 0; x < NUM_TILES_X; x++) {
      for (int y = 0; y < NUM_TILES_Y; y++) {
        wObjectsInLevel[x][y] = new Ground(x, y, whichGround);
      }
    }

    noStroke();

    imageMode(CORNER);
    // draw background
    switch (level) {
    case 2:
      bg = 0xffA0A0A0;
      break;
    case 3:
      bg = 0xff774E00;
      break;
    default:
      bg = 0xff71594d;
    }
    background(bg);

    // goal coordinates are negative before goal is set
    goalX1 = -1;
    goalY1 = -1;
    goalX2 = -1;
    goalY2 = -1;

    levelEditor = new LevelEditor(level);

    addCharacters();

    grm.allUfoPiecesCollected = false;
  }
  //---------------------------------------------------------

  public void draw() {

    // change coordinate system
    scale(width / (float) NUM_TILES_X, height / (float) NUM_TILES_Y);

    // schleife über alle wObjectsInLevel, alle zeichnen sich selbst an ihrer Position
    for (int x = 0; x < NUM_TILES_X; x++) {
      for (int y = 0; y < NUM_TILES_Y; y++) {
        wObjectsInLevel[x][y].draw();
      }
    }
  }
  //---------------------------------------------------------

  public void resetLitTiles() {
    push();
    scale(width / (float) NUM_TILES_X, height / (float) NUM_TILES_Y);
    for (int x = 0; x < NUM_TILES_X; x++) {
      for (int y = 0; y < NUM_TILES_Y; y++) {

        if (litTiles[x][y]) {
          fill(bg);
          rectMode(CORNER);
          rect(x-0.02f, y-0.02f, 1.04f, 1.04f);
        }

        litTiles[x][y] = false;
      }
    }
    pop();
  }
  //---------------------------------------------------------

  // initialise Characters
  public void addCharacters() {
    // clear list
    humans.clear();
    // add humans    Konstruktor (int _posX, int _posY, int _state, float _fieldOfView, int _sightdistance, boolean _hasLamp, boolean _reactsToNoiseItem)
    // initial states:   STILL = 0; PATROLING = 1 others only in runtime
    switch (level) {
    case 2:    //not in use
      break;
    case 3:  
      humans.add(new Human(21, 14, 1, 90, 4, true, false));
      humans.add(new Human(13, 14, 1, 90, 4, true, false));
      humans.add(new Human(32, 26, 0, 90, 4, true, true));
      break;
    default:
      humans.add(new Human(5, 11, 1, 90, 4, true, false));
      humans.add(new Human(26, 16, 1, 90, 4, true, false));
      humans.add(new Human(32, 26, 0, 90, 4, true, true));
    }

    // add aliens
    alien1 = new Alien(1, 26, '1');
    alien2 = new Alien(3, 26, '2');
  }
}
class WorldObject {
  int x;
  int y;
  boolean walkable;
  String whichObject;

  public void draw() {
  }
}

abstract class InteractiveWorldObject extends WorldObject {
  public abstract void act();
}
  public void settings() {  size(1280, 720); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "Game" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
