//Plug-In for Buttons
import controlP5.*;

public LevelEditor levelEditor;

public GameMode currentGameMode;
public HomeMode homeMode;
public GameRunningMode grm;
public GameWonMode gwm;
public GameLostMode glm;
public GameTutorialMode gtm;
public GameCreditsMode gcm;
public UI ui;

ControlP5 cp5;


PImage alien1Img;
PImage alien2Img;
PImage humanImg;
PImage speechBubbleImg;
PImage exclamationPointImg;

PImage boxImg;
PImage greenButtonImg;
PImage gardenGateLeftImg;
PImage gardenGateRightImg;
PImage gardenGateBottomImg;
PImage gardenGateTopImg;
PImage barrierLeftImg;
PImage barrierMiddleImg;
PImage barrierRightImg;
PImage doorTopImg;
PImage doorRightImg;
PImage doorBottomImg;
PImage doorLeftImg;
PImage leavesImg;
PImage streetImg;
PImage footpathImg;
PImage l3GroundImg;
PImage carpetImg;
PImage carpetTopLeftImg;
PImage carpetTopRightImg;
PImage carpetBottomLeftImg;
PImage carpetBottomRightImg;
PImage carpetSideTopImg;
PImage carpetSideBottomImg;
PImage lampImg;
PImage bucketImg;
PImage tvImg;
PImage treeImg;
PImage ufoImg;
PImage bushImg;
PImage wallWithHoleImg;
PImage grassImg;
PImage roofImg;
PImage housewallImg;
PImage plantImg;
PImage sofaImg;
PImage tableImg;

import ddf.minim.*;
Minim minim = new Minim(this);
AudioPlayer bgMusic;

void setup() {

  cp5 = new ControlP5(this);

  size(1280, 720);
  //Startet einen bestimmtem Mode
  ui = new UI(this);

  homeMode = new HomeMode(this, cp5, ui);
  grm = new GameRunningMode(this, cp5, ui);
  gwm = new GameWonMode(this, cp5, ui);
  glm = new GameLostMode(this, cp5, ui);
  gtm = new GameTutorialMode(this, cp5, ui);
  gcm = new GameCreditsMode(this, cp5, ui);
  currentGameMode = homeMode;

  ui.updateUI();

  bgMusic = minim.loadFile("sound/Guerilla Tactics.mp3");
  bgMusic.loop();

  // load Images for Characters and Assets
  alien1Img = loadImage("characters/alien_01.png");
  alien2Img = loadImage("characters/alien_02.png");
  humanImg = loadImage("characters/human.png");
  speechBubbleImg = loadImage("characters/speech_bubble.png");
  exclamationPointImg = loadImage("characters/exclamation_point.png");

  boxImg = loadImage("assets/box_01.png");
  greenButtonImg = loadImage("assets/button.png");
  gardenGateLeftImg = loadImage("assets/door/gardenGate_l.png");      
  gardenGateRightImg = loadImage("assets/door/gardenGate_r.png");
  gardenGateBottomImg = loadImage("assets/door/gardenGate_b.png");
  gardenGateTopImg = loadImage("assets/door/gardenGate_t.png");
  barrierLeftImg = loadImage("assets/door/barrier_l.png");
  barrierMiddleImg = loadImage("assets/door/barrier_m.png");
  barrierRightImg = loadImage("assets/door/barrier_r.png");
  doorTopImg = loadImage("assets/door/door_t.png");
  doorRightImg = loadImage("assets/door/door_r.png");
  doorBottomImg = loadImage("assets/door/door_b.png");
  doorLeftImg = loadImage("assets/door/door_l.png");
  leavesImg = loadImage("assets/test_leaves.png");
  streetImg = loadImage("assets/street_02.png");
  footpathImg = loadImage("assets/footpath_01.png");
  l3GroundImg = loadImage("assets/l3_ground_01.png");
  carpetImg = loadImage("assets/carpet/carpet_small.png");
  carpetTopLeftImg = loadImage("assets/carpet/carpet_tl.png");
  carpetTopRightImg = loadImage("assets/carpet/carpet_tr.png");
  carpetBottomLeftImg = loadImage("assets/carpet/carpet_bl.png");
  carpetBottomRightImg = loadImage("assets/carpet/carpet_br.png");
  carpetSideTopImg = loadImage("assets/carpet/carpet_side_top.png");
  carpetSideBottomImg = loadImage("assets/carpet/carpet_side_bottom.png");
  lampImg = loadImage("assets/lamp_01.png");
  bucketImg = loadImage("assets/bucket_01.png");
  tvImg = loadImage("assets/tv_01.png");
  treeImg = loadImage("assets/LOE_tree_light.png");
  ufoImg = loadImage("assets/ufo.png");
  bushImg = loadImage("assets/busch.png");
  wallWithHoleImg = loadImage("assets/l3_wall_with_hole.png");
  grassImg = loadImage("assets/gras_01.png");
  roofImg = loadImage("assets/roof_01.png");
  housewallImg = loadImage("assets/l3_wall_01.png");
  plantImg = loadImage("assets/plant_01.png");
  sofaImg = loadImage("assets/sofa_big.png");
  tableImg = loadImage("assets/tabel_big.png");
}

void draw() {
  //Show HomeMode Screen first
  if (currentGameMode != null) {
    currentGameMode.drawGame();
  }
}
