class Ground extends WorldObject {
  boolean onlyAliens = false;
  boolean onlyHumans = false;
  int tint;

  Ground(int _x, int _y, String _whichObject) {
    x = _x;
    y = _y;
    tint = round(random(220, 255));

    whichObject = _whichObject;
    // load correct image
    switch (whichObject) {
    case "street":                // not in use, part of original level 2
      onlyAliens = true;
      break;
    case "footpath":              // not in use, part of original level 2
      onlyHumans = true;
      break;
    }
    walkable = true;
  }
  //---------------------------------------------------------

  void draw() {
    // draw correct ground image
    imageMode(CORNER);
    switch (whichObject) {
    case "leaves":
      tint(tint);
      image(leavesImg, x, y, 1, 1);
      noTint();
      break;
    case "street":
      image(streetImg, x, y, 1, 1);              // not in use, part of original level 2
      break;
    case "footpath":
      image(footpathImg, x, y, 1, 1);            // not in use, part of original level 2
      break;
    case "l3 ground":
      image(l3GroundImg, x, y, 1, 1);
      break;
    case "carpet":
      image(carpetImg, x, y, 1, 1);
      break;
    case "carpet top left":
      image(carpetTopLeftImg, x, y, 1, 1);
      break;
    case "carpet top right":
      image(carpetTopRightImg, x, y, 1, 1);
      break;
    case "carpet bottom left":
      image(carpetBottomLeftImg, x, y, 1, 1);
      break;
    case "carpet bottom right":
      image(carpetBottomRightImg, x, y, 1, 1);
      break;
    case "carpet side top":
      image(carpetSideTopImg, x, y, 1, 1);
      break;
    case "carpet side bottom":
      image(carpetSideBottomImg, x, y, 1, 1);
      break;
    }
  }
}
