import controlP5.*;
Game _game;
GameWonMode won;
GameLostMode lost;

//Contains Menu, Background and Ufo Animation
class HomeMode extends GameMode {

  PImage ufoAnim = loadImage("assets/ufo_02.png");
  PVector ufoPos = new PVector(150, 150);
  PVector direction = new PVector(1f, 1f);
  float velocity = 2.5;
  float ufoRadius = 100;

  public HomeMode(Game game, ControlP5 cp5, UI ui) {    
    super(game, cp5, ui);
    _game = game;
    ModeName = "HomeMode";
    direction.mult(velocity);
    ufoPos.x = random(1, width - ufoRadius -1);
    ufoPos.y = random(1, height - ufoRadius -1);
  }

  void start(boolean fromLevel2) {
    if (ui != null) {
      ui.updateUI();
    }
    background(0);
    if (ufoPos != null) {
      ufoPos.x = random(1, width - ufoRadius -1);
      ufoPos.y = random(1, height - ufoRadius -1);
    }
  }

  void drawGame() {
    background(0);
    Stars();
    UfoAnimation();
  }

  public void Stars() {
    randomSeed(1337);
    for (int star = 0; star < 1500; star++) {
      float h = noise(frameCount / 30.3f + star) * 255;
      point(random(0, width), random(0, height));
      stroke(h);
    }
  }

  public void UfoAnimation() {
    ufoAnim.resize(100, 100);
    ufoPos.add(direction);
    image(ufoAnim, ufoPos.x, ufoPos.y);

    //Collions Detection
    if (ufoPos.x > width - ufoRadius || ufoPos.x < 0 || ufoPos.y > height - ufoRadius || ufoPos.y < 0) {
      if (ufoPos.y > height - ufoRadius) {
        direction.y *= -1;
      }
      if (ufoPos.y < 0) {
        direction.y *= -1;
      }
      if (ufoPos.x > width - ufoRadius) {
        direction.x *= -1;
      }
      if (ufoPos.x < 0) {
        direction.x *= -1;
      }
    }
    //---------------------------------------------------------
  }
}

//Function of Buttons
public void Level_1() {
  _game.currentGameMode = gtm;
  _game.currentGameMode.start(false);
}

public void Level_2() {
  startLevel(3);
}
public void Credits() {
  _game.currentGameMode = gcm;
  _game.currentGameMode.start(false);
}

public void Exit() {
  exit();
}

//---------------------------------------------------------


//Starts correct Level
void startLevel(int levelIndex) {
  _game.currentGameMode = grm;
  _game.currentGameMode.start(false);
  World newWorld = new World(levelIndex); 
  grm.world = newWorld;
}
//------------------------------------------------------
