int doorIDCounter = 0;

class LevelEditor {

  PImage level1;
  PImage level2;
  PImage level3;

  int tilesX = 42;
  int tilesY = 28;

  public LevelEditor(int level) {
    level1 = loadImage("levels/level_01.png");
    level2 = loadImage("levels/level_02.png");
    level3 = loadImage("levels/level_03.png");
    colorMode(RGB);
    readPixel(level);
  }
  //goes through all Tiles to detect color of each pixel
  void readPixel(int level) {

    // reset numer of UfoPieces in Level to 0
    maxUfoPieces = 0;

    color c = color(0);
    for (int x = 0; x < tilesX; x++) {
      for (int y = 0; y < tilesY; y++) {
        switch(level) {
        case 1:
          c = level1.get(x, y);
          break;
        case 2:
          c = level2.get(x, y);
          break;
        case 3:
          c = level3.get(x, y);
          break;
        }
        drawObjectsLevel(red(c), green(c), blue(c), x, y);
      }
    }
    addButtons(level);
  }

  //draws Level (RGB colors, x/y Positions, Level)
  //gets Value from readPixel decides which png belongs to which Tile
  void drawObjectsLevel(float r, float g, float b, int x, int y) {
    if (r == 100 && g == 100 && b == 100) {
      wObjectsInLevel[x][y] = new Ground(x, y, "street");
    }
    if (r == 35 && g == 35 && b == 35) {
      wObjectsInLevel[x][y] = new Ground(x, y, "footpath");
    }
    if (r == 0 && g == 255 && b == 0) {
      wObjectsInLevel[x][y] = new Wall(x, y, "tree");
    }
    if (r == 175 && g == 100 && b == 0) {
      wObjectsInLevel[x][y] = new Wall(x, y, "housewall");
    }
    if (r == 100 && g == 130 && b == 100) {
      wObjectsInLevel[x][y] = new Wall(x, y, "ufo");
      // same ufo on these tiles
      for (int i = 0; i < 6; i++) {
        for (int j = 0; j < 5; j++) {
          wObjectsInLevel[x+i][y+j] = wObjectsInLevel[x][y];
        }
      }
    }
    if (r == 130 && g == 50 && b == 50) {
      wObjectsInLevel[x][y] = new Wall(x, y, "roof");
    }
    if (r == 0 && g == 100 && b == 50) {
      wObjectsInLevel[x][y] = new NoiseItem(x, y, "tv");
    }
    // Wall with hole
    if (r == 100 && g == 100 && b == 0) {
      wObjectsInLevel[x][y] = new Wall(x, y, "bush");
    }
    if (r == 175 && g == 175 && b == 0) {
      wObjectsInLevel[x][y] = new Wall(x, y, "wall with hole");
    }
    if (r == 0 && g == 150 && b == 100) {
      wObjectsInLevel[x][y] = new Wall(x, y, "plant");
    }
    if (r == 255 && g == 0 && b == 0) {
      wObjectsInLevel[x][y] = new DoorMaker(x, y, doorIDCounter, "garden gate", wObjectsInLevel[x][y].whichObject);
      DoorMaker dm = (DoorMaker) wObjectsInLevel[x][y];
      dm.buildDoor();
      doorIDCounter++;
    }
    if (r == 255 && g == 100 && b== 100) {
      wObjectsInLevel[x][y] = new DoorMaker(x, y, doorIDCounter, "barrier", wObjectsInLevel[x][y].whichObject);
      DoorMaker dm = (DoorMaker) wObjectsInLevel[x][y];
      dm.buildDoor();
      doorIDCounter++;
    }
    if (r == 0 && g == 0 && b == 100) {
      wObjectsInLevel[x][y] = new DoorMaker(x, y, doorIDCounter, "door", wObjectsInLevel[x][y].whichObject);
      DoorMaker dm = (DoorMaker) wObjectsInLevel[x][y];
      dm.buildDoor();
      doorIDCounter++;
    }
    if (r == 0 && g == 255 && b == 255) {
      wObjectsInLevel[x][y] = new NoiseItem(x, y, "bucket");
    }
    if (r == 0 && g == 150 && b == 50) {
      wObjectsInLevel[x][y] = new Lamp(x, y, "lamp");
    }
    if (r == 0 && g == 0 && b == 255) {
      wObjectsInLevel[x][y] = new UfoPiece(x, y);
      maxUfoPieces++;
    }
    if (r == 55 && g == 44 && b == 33) {
      wObjectsInLevel[x][y] = new Box(x, y, "l3 ground");
    }
    // Tabel
    if (r == 80 && g == 100 && b == 100) {
      wObjectsInLevel[x][y] = new Wall(x, y, "tabel");
      for (int i = 0; i < 3; i++) {
        for (int j = 0; j < 2; j++) {
          wObjectsInLevel[x+i][y+j] = wObjectsInLevel[x][y];
        }
      }
    }
    if (r == 0 && g == 50 && b == 50) {
      wObjectsInLevel[x][y] = new Wall(x, y, "sofa"); 
      for (int i = 0; i < 3; i++) {
        for (int j = 0; j < 2; j++) {
          wObjectsInLevel[x+i][y+j] = wObjectsInLevel[x][y];
        }
      }
    }
    if (r == 0 && g == 100 && b == 100) {
      wObjectsInLevel[x][y] = new Ground(x, y, "carpet");
    }
    if (r == 0 && g == 71 && b == 71) {
      wObjectsInLevel[x][y] = new Ground(x, y, "carpet top left");
    }
    if (r == 0 && g == 130 && b == 130) {
      wObjectsInLevel[x][y] = new Ground(x, y, "carpet bottom left");
    }
    if (r == 0 && g == 220 && b == 220) {
      wObjectsInLevel[x][y] = new Ground(x, y, "carpet top right");
    }
    if (r == 0 && g == 190 && b == 190) {
      wObjectsInLevel[x][y] = new Ground(x, y, "carpet bottom right");
    }
    if (r == 0 && g == 160 && b == 160) {
      wObjectsInLevel[x][y] = new Ground(x, y, "carpet side top");
    }
    if (r == 0 && g == 250 && b == 250) {
      wObjectsInLevel[x][y] = new Ground(x, y, "carpet side bottom");
    }

    // Goal (Ground)
    if (r == 255 && g == 0 && b == 229) {
      if (goalX1 < 0) {
        goalX1 = x;
        goalY1 = y;
      } else if (goalX2 < 0) {
        goalX2 = x;
        goalY2 = y;
      }
    }
  }

  // adds button
  // has to be called at the end, so the objects the buttons are connected to already exist
  void addButtons(int level) {
    switch (level) {
    case 1:
      wObjectsInLevel[11][16] = new Button(11, 16, "green button", (InteractiveWorldObject) wObjectsInLevel[14][16]);
      break;
    case 3:
      break;
    }
  }
}
