// object that calls listening humans to it when acted with

class NoiseItem extends InteractiveWorldObject {
  AudioPlayer noise;
  int timeLastActed = timeOutTime;
  boolean isAlsoLamp;
  Lamp l;
  WorldObject neighbour;

  NoiseItem(int _x, int _y, String _whichObject) {
    x = _x;
    y = _y;
    whichObject = _whichObject;
    walkable = false;
    isAlsoLamp = false;
    // load correct image and sound
    switch(whichObject) {
    case "bucket":
      noise = minim.loadFile("sound/zapsplat_impact_metal_tray_tin_hit_blunt_med_pitched_resonate_ring_004_43391.mp3");
      neighbour = wObjectsInLevel[x+1][y];
      break;
    case "tv":
      noise = minim.loadFile("sound/glitched_tones_Hum+04.mp3");
      isAlsoLamp = true;
      neighbour = wObjectsInLevel[x][y-1];
      l = new Lamp(x, y, "lamp");
      l.on = false;
      break;
    }
  }
  //---------------------------------------------------------
  void draw() {
    if (isAlsoLamp) {
      l.fov();
      l.lightTiles();
    }
    imageMode(CORNER);
    switch(whichObject) {
    case "bucket":
      image(bucketImg, x, y, 1, 1);
      break;
    case "tv":
      image(tvImg, x, y, 1, 1);
      break;
    }
  }
  //---------------------------------------------------------

  void act() {
    // only acts once every second
    if (timeLastActed > timer) {
      if (isAlsoLamp) {
        l.act();
        if (l.on) {
          this.noise.rewind();
          this.noise.play();
        } else {
          this.noise.pause();
        }
      } else {
        this.noise.rewind();
        this.noise.play();
      }

      timeLastActed = timer;

      // tell humans that a noise was made and where
      for (Human human : humans) {
        human.reactToNoise(this, neighbour);
      }
    }
  }
}
