import controlP5.*;

//HomeMode Buttons
controlP5.Button level1Button;
controlP5.Button level2Button;
controlP5.Button creditsButton;
controlP5.Button exitButton;
controlP5.Button menuButton;
controlP5.Button page2Button;
//---------------------------------------

//GameLostMode
controlP5.Button backButtonLost;
//---------------------------------------

//GameWonMode
controlP5.Button backButtonWon;
//---------------------------------------

//Button Image for Credits 
PImage page2ButtonImage;
PImage page1ButtonImage;

//---------------------------------------

class UI {

  Game game;

  public UI(Game game) {
    this.game = game;
    start();
  }

  public void start() {
    createButtons();
    hideButtons();
  }

  void createButtons() {

    //Konstruktor: String Name, Value Float, X int, Y int, Width int, Height int
    //HomeMode Buttons
    level1Button = game.cp5.addButton("Level_1", 0, width/2 - 100, height/2 - 150, 200, 50);
    level1Button.setPosition(width/2 - 100, height/2 - 150);
    PImage level1Image = loadImage("Buttons/Button_level1_01.png");
    level1Image.resize(200, 50);
    level1Button.setImage(level1Image);

    level2Button = game.cp5.addButton("Level_2", 0, width/2 - 100, height/2 - 50, 200, 50);
    level2Button.setPosition(width/2 - 100, height/2 - 50);
    PImage level2Image = loadImage("Buttons/Button_level2_01.png");
    level2Image.resize(200, 50);
    level2Button.setImage(level2Image);

    creditsButton = game.cp5.addButton("Credits", 0, width/2 - 100, height/2 + 50, 200, 50);
    creditsButton.setPosition(width/2 - 100, height/2 + 50);
    PImage creditsButtonImage = loadImage("Buttons/Button_credits_01.png");
    creditsButtonImage.resize(200, 50);
    creditsButton.setImage(creditsButtonImage);

    exitButton = game.cp5.addButton("Exit", 0, width/2 - 100, height/2 + 150, 200, 50);
    exitButton.setPosition(width/2 - 100, height/2 + 150);
    PImage exitButtonImage = loadImage("Buttons/Button_exit_01.png");
    exitButtonImage.resize(200, 50);
    exitButton.setImage(exitButtonImage);
    //----------------------------------------------------------------------------------------

    //GameWonMode Button
    backButtonWon = game.cp5.addButton("Back", 0, width/2 - 100, height/2, 200, 50);
    backButtonWon.setPosition(width/2 - 100, height/2 + 150);
    PImage backButtonImage = loadImage("Buttons/Button_Back_01.png");
    backButtonImage.resize(200, 50);
    backButtonWon.setImage(backButtonImage);
    //----------------------------------------------------------------------------------------

    //GameLostMode
    backButtonLost = game.cp5.addButton("TryAgain", 0, width/2 - 100, height/2, 200, 50);
    backButtonLost.setPosition(width/2 - 100, height/2 + 100);
    PImage lostButtonImage = loadImage("Buttons/Button_tryAgain_01.png");
    lostButtonImage.resize(200, 50);
    backButtonLost.setImage(lostButtonImage);
    //----------------------------------------------------------------------------------------

    //GameCreditsMode
    menuButton = game.cp5.addButton("Menu", 0, width/2 - 100, height/2, 200, 50);
    menuButton.setPosition(width/2 - 100, height/2 + 280);
    PImage menuButtonImage = loadImage("Buttons/Button_menu_01.png");
    menuButtonImage.resize(200, 50);
    menuButton.setImage(menuButtonImage);
    //----------------------------------------------------------------------------------------

    //GameCreditsMode
    page2Button = game.cp5.addButton("CreditsToggel", 0, width/2 - 100, height/2, 200, 50);
    page2Button.setPosition(width/2 + 300, height/2 + 280);
    page2ButtonImage = loadImage("Buttons/Button_Back_01.png");
    page1ButtonImage = loadImage("Buttons/Button_Next_01.png");
    page2ButtonImage.resize(200, 50);
    page1ButtonImage.resize(200, 50);
    page2Button.setImage(page2ButtonImage);
    //----------------------------------------------------------------------------------------
  }

  void hideButtons() {

    //HomeMode Buttons
    level1Button.hide();
    level2Button.hide();
    creditsButton.hide();
    exitButton.hide();
    //----------------------------------------------------------------------------------------  

    //GameWonMode
    backButtonWon.hide();
    //----------------------------------------------------------------------------------------

    //GameLostMode
    backButtonLost.hide();
    //----------------------------------------------------------------------------------------

    //GameCreditsMode
    menuButton.hide();
    //----------------------------------------------------------------------------------------
    //GameCreditsMode
    page2Button.hide();
    //----------------------------------------------------------------------------------------
  }

  void updateUI() {
    hideButtons();
    if (game.currentGameMode != null) {

      switch(game.currentGameMode.ModeName) {
      case "HomeMode":
        level1Button.show();
        level2Button.show();
        creditsButton.show();
        exitButton.show();
        break;
      case "GameWonMode":
        backButtonWon.show();
        break;
      case "GameLostMode":
        backButtonLost.show();
        break;
      case "GameRunningMode":
        hideButtons();
        break;
      case "GameTutorialMode":
        hideButtons();
        break;
      case "GameCreditsMode":
        menuButton.show();
        page2Button.show();
        break;
      }
    }
  }
}
