// obstacles in the level; some walls have holes that the small alien can go through

class Wall extends WorldObject {
  boolean drawn;
  int nrOfTiles;
  int countTillDraw = 0;
  boolean hasSmallHole;
  int tint;                          // for color variation of trees

  Wall(int _x, int _y, String _whichObject) {
    x = _x;
    y = _y;
    whichObject = _whichObject;
    walkable = false;
    drawn = false;
    tint = round(random(230, 255));

    switch (whichObject) {
    case "ufo":
      nrOfTiles = 30;
      hasSmallHole = false;
      break;
      // wall with hole
    case "bush":
      nrOfTiles = 1;
      hasSmallHole = true;
      break;
    case "wall with hole":
      nrOfTiles = 1;
      hasSmallHole = true;
      break;
    case "sofa":
      nrOfTiles = 6;
      hasSmallHole = false;
      break;
    case "tabel":
      nrOfTiles = 6;
      hasSmallHole = false;
      break;
    default:
      nrOfTiles = 1;
      hasSmallHole = false;
    }
  }
  //---------------------------------------------------------

  void draw() {
    // only draw once every frame
    if (drawn) {
      if (countTillDraw == 1) {
        this.drawn = false;
      }
      countTillDraw--;
    } else {
      imageMode(CORNER);
      switch (whichObject) {
      case "tree":
        tint(tint);
        image(treeImg, x, y, 1, 1);
        noTint();
        break;
      case "ufo":
        image(ufoImg, x, y, 6, 5);
        this.drawn = true;
        countTillDraw = nrOfTiles;
        break;
        // wall with hole
      case "bush":
        image(bushImg, x, y, 1, 1);
        break;
      case "wall with hole":
        image(wallWithHoleImg, x, y, 1, 1);
        break;
      case "grass":
        image(grassImg, x, y, 1, 1);
        break;
      case "roof":
        image(roofImg, x, y, 1, 1);
        break;
      case "housewall":
        image(housewallImg, x, y, 1, 1);
        break;
      case "plant":
        image(plantImg, x, y, 1, 1);
        break;
      case "sofa":
        image(sofaImg, x, y, 3, 2); 
        this.drawn = true;
        countTillDraw = nrOfTiles;
        break;
      case "tabel":
        image(tableImg, x, y, 3, 2); 
        this.drawn = true;
        countTillDraw = nrOfTiles;
        break;
      }
    }
  }
}
