public final int NUM_TILES_X = 42;
public final int NUM_TILES_Y = 28;
public final float tileWidth = (float) 1280 / NUM_TILES_X;
public final float tileHeight = (float) 720 / NUM_TILES_Y;
WorldObject wObjectsInLevel[][] = new WorldObject[NUM_TILES_X][NUM_TILES_Y];      // all objects of the level are saved in this array
boolean litTiles[][] = new boolean[NUM_TILES_X][NUM_TILES_Y];
java.util.LinkedList<Human> humans = new java.util.LinkedList();
public Alien alien1;
public Alien alien2;

// goal coordinates
int goalX1;
int goalY1;
int goalX2;
int goalY2;

GameRunningMode _grm;

class World {
  int level;
  color bg;
  String whichGround;

  World(int _level) {
    level = _level;

    switch (level) {
    case 1:
      whichGround = "leaves";
      break;
    case 3:
      whichGround = "l3 ground";
      break;
    }

    for (int x = 0; x < NUM_TILES_X; x++) {
      for (int y = 0; y < NUM_TILES_Y; y++) {
        wObjectsInLevel[x][y] = new Ground(x, y, whichGround);
      }
    }

    noStroke();

    imageMode(CORNER);
    // draw background
    switch (level) {
    case 2:
      bg = #A0A0A0;
      break;
    case 3:
      bg = #774E00;
      break;
    default:
      bg = #71594d;
    }
    background(bg);

    // goal coordinates are negative before goal is set
    goalX1 = -1;
    goalY1 = -1;
    goalX2 = -1;
    goalY2 = -1;

    levelEditor = new LevelEditor(level);

    addCharacters();

    grm.allUfoPiecesCollected = false;
  }
  //---------------------------------------------------------

  void draw() {

    // change coordinate system
    scale(width / (float) NUM_TILES_X, height / (float) NUM_TILES_Y);

    // schleife über alle wObjectsInLevel, alle zeichnen sich selbst an ihrer Position
    for (int x = 0; x < NUM_TILES_X; x++) {
      for (int y = 0; y < NUM_TILES_Y; y++) {
        wObjectsInLevel[x][y].draw();
      }
    }
  }
  //---------------------------------------------------------

  void resetLitTiles() {
    push();
    scale(width / (float) NUM_TILES_X, height / (float) NUM_TILES_Y);
    for (int x = 0; x < NUM_TILES_X; x++) {
      for (int y = 0; y < NUM_TILES_Y; y++) {

        if (litTiles[x][y]) {
          fill(bg);
          rectMode(CORNER);
          rect(x-0.02, y-0.02, 1.04, 1.04);
        }

        litTiles[x][y] = false;
      }
    }
    pop();
  }
  //---------------------------------------------------------

  // initialise Characters
  void addCharacters() {
    // clear list
    humans.clear();
    // add humans    Konstruktor (int _posX, int _posY, int _state, float _fieldOfView, int _sightdistance, boolean _hasLamp, boolean _reactsToNoiseItem)
    // initial states:   STILL = 0; PATROLING = 1 others only in runtime
    switch (level) {
    case 2:    //not in use
      break;
    case 3:  
      humans.add(new Human(21, 14, 1, 90, 4, true, false));
      humans.add(new Human(13, 14, 1, 90, 4, true, false));
      humans.add(new Human(32, 26, 0, 90, 4, true, true));
      break;
    default:
      humans.add(new Human(5, 11, 1, 90, 4, true, false));
      humans.add(new Human(26, 16, 1, 90, 4, true, false));
      humans.add(new Human(32, 26, 0, 90, 4, true, true));
    }

    // add aliens
    alien1 = new Alien(1, 26, '1');
    alien2 = new Alien(3, 26, '2');
  }
}
